#ifndef _Office_HPP_INCLUDED
#define _Office_HPP_INCLUDED

#pragma warning 849 9 // "Warning! base class virtual function has not been overriden"
#include "wstdtype.hpp"
#include "OfficeUser97.hpp"

#ifdef __OPTIMA_USE_COMPONENT_LIBRARIES__
#  pragma library ("Office97.lib")
#endif // __OPTIMA_USE_COMPONENT_LIBRARIES__

typedef long MsoLineDashStyle;
#define MsoLineDashStylemsoLineDashStyleMixed -2
#define MsoLineDashStylemsoLineSolid 1
#define MsoLineDashStylemsoLineSquareDot 2
#define MsoLineDashStylemsoLineRoundDot 3
#define MsoLineDashStylemsoLineDash 4
#define MsoLineDashStylemsoLineDashDot 5
#define MsoLineDashStylemsoLineDashDotDot 6
#define MsoLineDashStylemsoLineLongDash 7
#define MsoLineDashStylemsoLineLongDashDot 8

typedef long MsoLineStyle;
#define MsoLineStylemsoLineStyleMixed -2
#define MsoLineStylemsoLineSingle 1
#define MsoLineStylemsoLineThinThin 2
#define MsoLineStylemsoLineThinThick 3
#define MsoLineStylemsoLineThickThin 4
#define MsoLineStylemsoLineThickBetweenThin 5

typedef long MsoArrowheadStyle;
#define MsoArrowheadStylemsoArrowheadStyleMixed -2
#define MsoArrowheadStylemsoArrowheadNone 1
#define MsoArrowheadStylemsoArrowheadTriangle 2
#define MsoArrowheadStylemsoArrowheadOpen 3
#define MsoArrowheadStylemsoArrowheadStealth 4
#define MsoArrowheadStylemsoArrowheadDiamond 5
#define MsoArrowheadStylemsoArrowheadOval 6

typedef long MsoArrowheadWidth;
#define MsoArrowheadWidthmsoArrowheadWidthMixed -2
#define MsoArrowheadWidthmsoArrowheadNarrow 1
#define MsoArrowheadWidthmsoArrowheadWidthMedium 2
#define MsoArrowheadWidthmsoArrowheadWide 3

typedef long MsoArrowheadLength;
#define MsoArrowheadLengthmsoArrowheadLengthMixed -2
#define MsoArrowheadLengthmsoArrowheadShort 1
#define MsoArrowheadLengthmsoArrowheadLengthMedium 2
#define MsoArrowheadLengthmsoArrowheadLong 3

typedef long MsoFillType;
#define MsoFillTypemsoFillMixed -2
#define MsoFillTypemsoFillSolid 1
#define MsoFillTypemsoFillPatterned 2
#define MsoFillTypemsoFillGradient 3
#define MsoFillTypemsoFillTextured 4
#define MsoFillTypemsoFillBackground 5
#define MsoFillTypemsoFillPicture 6

typedef long MsoGradientStyle;
#define MsoGradientStylemsoGradientMixed -2
#define MsoGradientStylemsoGradientHorizontal 1
#define MsoGradientStylemsoGradientVertical 2
#define MsoGradientStylemsoGradientDiagonalUp 3
#define MsoGradientStylemsoGradientDiagonalDown 4
#define MsoGradientStylemsoGradientFromCorner 5
#define MsoGradientStylemsoGradientFromTitle 6
#define MsoGradientStylemsoGradientFromCenter 7

typedef long MsoGradientColorType;
#define MsoGradientColorTypemsoGradientColorMixed -2
#define MsoGradientColorTypemsoGradientOneColor 1
#define MsoGradientColorTypemsoGradientTwoColors 2
#define MsoGradientColorTypemsoGradientPresetColors 3

typedef long MsoTextureType;
#define MsoTextureTypemsoTextureTypeMixed -2
#define MsoTextureTypemsoTexturePreset 1
#define MsoTextureTypemsoTextureUserDefined 2

typedef long MsoPresetTexture;
#define MsoPresetTexturemsoPresetTextureMixed -2
#define MsoPresetTexturemsoTexturePapyrus 1
#define MsoPresetTexturemsoTextureCanvas 2
#define MsoPresetTexturemsoTextureDenim 3
#define MsoPresetTexturemsoTextureWovenMat 4
#define MsoPresetTexturemsoTextureWaterDroplets 5
#define MsoPresetTexturemsoTexturePaperBag 6
#define MsoPresetTexturemsoTextureFishFossil 7
#define MsoPresetTexturemsoTextureSand 8
#define MsoPresetTexturemsoTextureGreenMarble 9
#define MsoPresetTexturemsoTextureWhiteMarble 10
#define MsoPresetTexturemsoTextureBrownMarble 11
#define MsoPresetTexturemsoTextureGranite 12
#define MsoPresetTexturemsoTextureNewsprint 13
#define MsoPresetTexturemsoTextureRecycledPaper 14
#define MsoPresetTexturemsoTextureParchment 15
#define MsoPresetTexturemsoTextureStationery 16
#define MsoPresetTexturemsoTextureBlueTissuePaper 17
#define MsoPresetTexturemsoTexturePinkTissuePaper 18
#define MsoPresetTexturemsoTexturePurpleMesh 19
#define MsoPresetTexturemsoTextureBouquet 20
#define MsoPresetTexturemsoTextureCork 21
#define MsoPresetTexturemsoTextureWalnut 22
#define MsoPresetTexturemsoTextureOak 23
#define MsoPresetTexturemsoTextureMediumWood 24

typedef long MsoPatternType;
#define MsoPatternTypemsoPatternMixed -2
#define MsoPatternTypemsoPattern5Percent 1
#define MsoPatternTypemsoPattern10Percent 2
#define MsoPatternTypemsoPattern20Percent 3
#define MsoPatternTypemsoPattern25Percent 4
#define MsoPatternTypemsoPattern30Percent 5
#define MsoPatternTypemsoPattern40Percent 6
#define MsoPatternTypemsoPattern50Percent 7
#define MsoPatternTypemsoPattern60Percent 8
#define MsoPatternTypemsoPattern70Percent 9
#define MsoPatternTypemsoPattern75Percent 10
#define MsoPatternTypemsoPattern80Percent 11
#define MsoPatternTypemsoPattern90Percent 12
#define MsoPatternTypemsoPatternDarkHorizontal 13
#define MsoPatternTypemsoPatternDarkVertical 14
#define MsoPatternTypemsoPatternDarkDownwardDiagonal 15
#define MsoPatternTypemsoPatternDarkUpwardDiagonal 16
#define MsoPatternTypemsoPatternSmallCheckerBoard 17
#define MsoPatternTypemsoPatternTrellis 18
#define MsoPatternTypemsoPatternLightHorizontal 19
#define MsoPatternTypemsoPatternLightVertical 20
#define MsoPatternTypemsoPatternLightDownwardDiagonal 21
#define MsoPatternTypemsoPatternLightUpwardDiagonal 22
#define MsoPatternTypemsoPatternSmallGrid 23
#define MsoPatternTypemsoPatternDottedDiamond 24
#define MsoPatternTypemsoPatternWideDownwardDiagonal 25
#define MsoPatternTypemsoPatternWideUpwardDiagonal 26
#define MsoPatternTypemsoPatternDashedUpwardDiagonal 27
#define MsoPatternTypemsoPatternDashedDownwardDiagonal 28
#define MsoPatternTypemsoPatternNarrowVertical 29
#define MsoPatternTypemsoPatternNarrowHorizontal 30
#define MsoPatternTypemsoPatternDashedVertical 31
#define MsoPatternTypemsoPatternDashedHorizontal 32
#define MsoPatternTypemsoPatternLargeConfetti 33
#define MsoPatternTypemsoPatternLargeGrid 34
#define MsoPatternTypemsoPatternHorizontalBrick 35
#define MsoPatternTypemsoPatternLargeCheckerBoard 36
#define MsoPatternTypemsoPatternSmallConfetti 37
#define MsoPatternTypemsoPatternZigZag 38
#define MsoPatternTypemsoPatternSolidDiamond 39
#define MsoPatternTypemsoPatternDiagonalBrick 40
#define MsoPatternTypemsoPatternOutlinedDiamond 41
#define MsoPatternTypemsoPatternPlaid 42
#define MsoPatternTypemsoPatternSphere 43
#define MsoPatternTypemsoPatternWeave 44
#define MsoPatternTypemsoPatternDottedGrid 45
#define MsoPatternTypemsoPatternDivot 46
#define MsoPatternTypemsoPatternShingle 47
#define MsoPatternTypemsoPatternWave 48

typedef long MsoPresetGradientType;
#define MsoPresetGradientTypemsoPresetGradientMixed -2
#define MsoPresetGradientTypemsoGradientEarlySunset 1
#define MsoPresetGradientTypemsoGradientLateSunset 2
#define MsoPresetGradientTypemsoGradientNightfall 3
#define MsoPresetGradientTypemsoGradientDaybreak 4
#define MsoPresetGradientTypemsoGradientHorizon 5
#define MsoPresetGradientTypemsoGradientDesert 6
#define MsoPresetGradientTypemsoGradientOcean 7
#define MsoPresetGradientTypemsoGradientCalmWater 8
#define MsoPresetGradientTypemsoGradientFire 9
#define MsoPresetGradientTypemsoGradientFog 10
#define MsoPresetGradientTypemsoGradientMoss 11
#define MsoPresetGradientTypemsoGradientPeacock 12
#define MsoPresetGradientTypemsoGradientWheat 13
#define MsoPresetGradientTypemsoGradientParchment 14
#define MsoPresetGradientTypemsoGradientMahogany 15
#define MsoPresetGradientTypemsoGradientRainbow 16
#define MsoPresetGradientTypemsoGradientRainbowII 17
#define MsoPresetGradientTypemsoGradientGold 18
#define MsoPresetGradientTypemsoGradientGoldII 19
#define MsoPresetGradientTypemsoGradientBrass 20
#define MsoPresetGradientTypemsoGradientChrome 21
#define MsoPresetGradientTypemsoGradientChromeII 22
#define MsoPresetGradientTypemsoGradientSilver 23
#define MsoPresetGradientTypemsoGradientSapphire 24

typedef long MsoShadowType;
#define MsoShadowTypemsoShadowMixed -2
#define MsoShadowTypemsoShadow1 1
#define MsoShadowTypemsoShadow2 2
#define MsoShadowTypemsoShadow3 3
#define MsoShadowTypemsoShadow4 4
#define MsoShadowTypemsoShadow5 5
#define MsoShadowTypemsoShadow6 6
#define MsoShadowTypemsoShadow7 7
#define MsoShadowTypemsoShadow8 8
#define MsoShadowTypemsoShadow9 9
#define MsoShadowTypemsoShadow10 10
#define MsoShadowTypemsoShadow11 11
#define MsoShadowTypemsoShadow12 12
#define MsoShadowTypemsoShadow13 13
#define MsoShadowTypemsoShadow14 14
#define MsoShadowTypemsoShadow15 15
#define MsoShadowTypemsoShadow16 16
#define MsoShadowTypemsoShadow17 17
#define MsoShadowTypemsoShadow18 18
#define MsoShadowTypemsoShadow19 19
#define MsoShadowTypemsoShadow20 20

typedef long MsoPresetTextEffect;
#define MsoPresetTextEffectmsoTextEffectMixed -2
#define MsoPresetTextEffectmsoTextEffect1 0
#define MsoPresetTextEffectmsoTextEffect2 1
#define MsoPresetTextEffectmsoTextEffect3 2
#define MsoPresetTextEffectmsoTextEffect4 3
#define MsoPresetTextEffectmsoTextEffect5 4
#define MsoPresetTextEffectmsoTextEffect6 5
#define MsoPresetTextEffectmsoTextEffect7 6
#define MsoPresetTextEffectmsoTextEffect8 7
#define MsoPresetTextEffectmsoTextEffect9 8
#define MsoPresetTextEffectmsoTextEffect10 9
#define MsoPresetTextEffectmsoTextEffect11 10
#define MsoPresetTextEffectmsoTextEffect12 11
#define MsoPresetTextEffectmsoTextEffect13 12
#define MsoPresetTextEffectmsoTextEffect14 13
#define MsoPresetTextEffectmsoTextEffect15 14
#define MsoPresetTextEffectmsoTextEffect16 15
#define MsoPresetTextEffectmsoTextEffect17 16
#define MsoPresetTextEffectmsoTextEffect18 17
#define MsoPresetTextEffectmsoTextEffect19 18
#define MsoPresetTextEffectmsoTextEffect20 19
#define MsoPresetTextEffectmsoTextEffect21 20
#define MsoPresetTextEffectmsoTextEffect22 21
#define MsoPresetTextEffectmsoTextEffect23 22
#define MsoPresetTextEffectmsoTextEffect24 23
#define MsoPresetTextEffectmsoTextEffect25 24
#define MsoPresetTextEffectmsoTextEffect26 25
#define MsoPresetTextEffectmsoTextEffect27 26
#define MsoPresetTextEffectmsoTextEffect28 27
#define MsoPresetTextEffectmsoTextEffect29 28
#define MsoPresetTextEffectmsoTextEffect30 29

typedef long MsoPresetTextEffectShape;
#define MsoPresetTextEffectShapemsoTextEffectShapeMixed -2
#define MsoPresetTextEffectShapemsoTextEffectShapePlainText 1
#define MsoPresetTextEffectShapemsoTextEffectShapeStop 2
#define MsoPresetTextEffectShapemsoTextEffectShapeTriangleUp 3
#define MsoPresetTextEffectShapemsoTextEffectShapeTriangleDown 4
#define MsoPresetTextEffectShapemsoTextEffectShapeChevronUp 5
#define MsoPresetTextEffectShapemsoTextEffectShapeChevronDown 6
#define MsoPresetTextEffectShapemsoTextEffectShapeRingInside 7
#define MsoPresetTextEffectShapemsoTextEffectShapeRingOutside 8
#define MsoPresetTextEffectShapemsoTextEffectShapeArchUpCurve 9
#define MsoPresetTextEffectShapemsoTextEffectShapeArchDownCurve 10
#define MsoPresetTextEffectShapemsoTextEffectShapeCircleCurve 11
#define MsoPresetTextEffectShapemsoTextEffectShapeButtonCurve 12
#define MsoPresetTextEffectShapemsoTextEffectShapeArchUpPour 13
#define MsoPresetTextEffectShapemsoTextEffectShapeArchDownPour 14
#define MsoPresetTextEffectShapemsoTextEffectShapeCirclePour 15
#define MsoPresetTextEffectShapemsoTextEffectShapeButtonPour 16
#define MsoPresetTextEffectShapemsoTextEffectShapeCurveUp 17
#define MsoPresetTextEffectShapemsoTextEffectShapeCurveDown 18
#define MsoPresetTextEffectShapemsoTextEffectShapeCanUp 19
#define MsoPresetTextEffectShapemsoTextEffectShapeCanDown 20
#define MsoPresetTextEffectShapemsoTextEffectShapeWave1 21
#define MsoPresetTextEffectShapemsoTextEffectShapeWave2 22
#define MsoPresetTextEffectShapemsoTextEffectShapeDoubleWave1 23
#define MsoPresetTextEffectShapemsoTextEffectShapeDoubleWave2 24
#define MsoPresetTextEffectShapemsoTextEffectShapeInflate 25
#define MsoPresetTextEffectShapemsoTextEffectShapeDeflate 26
#define MsoPresetTextEffectShapemsoTextEffectShapeInflateBottom 27
#define MsoPresetTextEffectShapemsoTextEffectShapeDeflateBottom 28
#define MsoPresetTextEffectShapemsoTextEffectShapeInflateTop 29
#define MsoPresetTextEffectShapemsoTextEffectShapeDeflateTop 30
#define MsoPresetTextEffectShapemsoTextEffectShapeDeflateInflate 31
#define MsoPresetTextEffectShapemsoTextEffectShapeDeflateInflateDeflate 32
#define MsoPresetTextEffectShapemsoTextEffectShapeFadeRight 33
#define MsoPresetTextEffectShapemsoTextEffectShapeFadeLeft 34
#define MsoPresetTextEffectShapemsoTextEffectShapeFadeUp 35
#define MsoPresetTextEffectShapemsoTextEffectShapeFadeDown 36
#define MsoPresetTextEffectShapemsoTextEffectShapeSlantUp 37
#define MsoPresetTextEffectShapemsoTextEffectShapeSlantDown 38
#define MsoPresetTextEffectShapemsoTextEffectShapeCascadeUp 39
#define MsoPresetTextEffectShapemsoTextEffectShapeCascadeDown 40

typedef long MsoTextEffectAlignment;
#define MsoTextEffectAlignmentmsoTextEffectAlignmentMixed -2
#define MsoTextEffectAlignmentmsoTextEffectAlignmentLeft 1
#define MsoTextEffectAlignmentmsoTextEffectAlignmentCentered 2
#define MsoTextEffectAlignmentmsoTextEffectAlignmentRight 3
#define MsoTextEffectAlignmentmsoTextEffectAlignmentLetterJustify 4
#define MsoTextEffectAlignmentmsoTextEffectAlignmentWordJustify 5
#define MsoTextEffectAlignmentmsoTextEffectAlignmentStretchJustify 6

typedef long MsoPresetLightingDirection;
#define MsoPresetLightingDirectionmsoPresetLightingDirectionMixed -2
#define MsoPresetLightingDirectionmsoLightingTopLeft 1
#define MsoPresetLightingDirectionmsoLightingTop 2
#define MsoPresetLightingDirectionmsoLightingTopRight 3
#define MsoPresetLightingDirectionmsoLightingLeft 4
#define MsoPresetLightingDirectionmsoLightingNone 5
#define MsoPresetLightingDirectionmsoLightingRight 6
#define MsoPresetLightingDirectionmsoLightingBottomLeft 7
#define MsoPresetLightingDirectionmsoLightingBottom 8
#define MsoPresetLightingDirectionmsoLightingBottomRight 9

typedef long MsoPresetLightingSoftness;
#define MsoPresetLightingSoftnessmsoPresetLightingSoftnessMixed -2
#define MsoPresetLightingSoftnessmsoLightingDim 1
#define MsoPresetLightingSoftnessmsoLightingNormal 2
#define MsoPresetLightingSoftnessmsoLightingBright 3

typedef long MsoPresetMaterial;
#define MsoPresetMaterialmsoPresetMaterialMixed -2
#define MsoPresetMaterialmsoMaterialMatte 1
#define MsoPresetMaterialmsoMaterialPlastic 2
#define MsoPresetMaterialmsoMaterialMetal 3
#define MsoPresetMaterialmsoMaterialWireFrame 4

typedef long MsoPresetExtrusionDirection;
#define MsoPresetExtrusionDirectionmsoPresetExtrusionDirectionMixed -2
#define MsoPresetExtrusionDirectionmsoExtrusionBottomRight 1
#define MsoPresetExtrusionDirectionmsoExtrusionBottom 2
#define MsoPresetExtrusionDirectionmsoExtrusionBottomLeft 3
#define MsoPresetExtrusionDirectionmsoExtrusionRight 4
#define MsoPresetExtrusionDirectionmsoExtrusionNone 5
#define MsoPresetExtrusionDirectionmsoExtrusionLeft 6
#define MsoPresetExtrusionDirectionmsoExtrusionTopRight 7
#define MsoPresetExtrusionDirectionmsoExtrusionTop 8
#define MsoPresetExtrusionDirectionmsoExtrusionTopLeft 9

typedef long MsoPresetThreeDFormat;
#define MsoPresetThreeDFormatmsoPresetThreeDFormatMixed -2
#define MsoPresetThreeDFormatmsoThreeD1 1
#define MsoPresetThreeDFormatmsoThreeD2 2
#define MsoPresetThreeDFormatmsoThreeD3 3
#define MsoPresetThreeDFormatmsoThreeD4 4
#define MsoPresetThreeDFormatmsoThreeD5 5
#define MsoPresetThreeDFormatmsoThreeD6 6
#define MsoPresetThreeDFormatmsoThreeD7 7
#define MsoPresetThreeDFormatmsoThreeD8 8
#define MsoPresetThreeDFormatmsoThreeD9 9
#define MsoPresetThreeDFormatmsoThreeD10 10
#define MsoPresetThreeDFormatmsoThreeD11 11
#define MsoPresetThreeDFormatmsoThreeD12 12
#define MsoPresetThreeDFormatmsoThreeD13 13
#define MsoPresetThreeDFormatmsoThreeD14 14
#define MsoPresetThreeDFormatmsoThreeD15 15
#define MsoPresetThreeDFormatmsoThreeD16 16
#define MsoPresetThreeDFormatmsoThreeD17 17
#define MsoPresetThreeDFormatmsoThreeD18 18
#define MsoPresetThreeDFormatmsoThreeD19 19
#define MsoPresetThreeDFormatmsoThreeD20 20

typedef long MsoExtrusionColorType;
#define MsoExtrusionColorTypemsoExtrusionColorTypeMixed -2
#define MsoExtrusionColorTypemsoExtrusionColorAutomatic 1
#define MsoExtrusionColorTypemsoExtrusionColorCustom 2

typedef long MsoAlignCmd;
#define MsoAlignCmdmsoAlignLefts 0
#define MsoAlignCmdmsoAlignCenters 1
#define MsoAlignCmdmsoAlignRights 2
#define MsoAlignCmdmsoAlignTops 3
#define MsoAlignCmdmsoAlignMiddles 4
#define MsoAlignCmdmsoAlignBottoms 5

typedef long MsoDistributeCmd;
#define MsoDistributeCmdmsoDistributeHorizontally 0
#define MsoDistributeCmdmsoDistributeVertically 1

typedef long MsoConnectorType;
#define MsoConnectorTypemsoConnectorTypeMixed -2
#define MsoConnectorTypemsoConnectorStraight 1
#define MsoConnectorTypemsoConnectorElbow 2
#define MsoConnectorTypemsoConnectorCurve 3

typedef long MsoHorizontalAnchor;
#define MsoHorizontalAnchormsoHorizontalAnchorMixed -2
#define MsoHorizontalAnchormsoAnchorNone 1
#define MsoHorizontalAnchormsoAnchorCenter 2

typedef long MsoVerticalAnchor;
#define MsoVerticalAnchormsoVerticalAnchorMixed -2
#define MsoVerticalAnchormsoAnchorTop 1
#define MsoVerticalAnchormsoAnchorTopBaseline 2
#define MsoVerticalAnchormsoAnchorMiddle 3
#define MsoVerticalAnchormsoAnchorBottom 4
#define MsoVerticalAnchormsoAnchorBottomBaseLine 5

typedef long MsoOrientation;
#define MsoOrientationmsoOrientationMixed -2
#define MsoOrientationmsoOrientationHorizontal 1
#define MsoOrientationmsoOrientationVertical 2

typedef long MsoZOrderCmd;
#define MsoZOrderCmdmsoBringToFront 0
#define MsoZOrderCmdmsoSendToBack 1
#define MsoZOrderCmdmsoBringForward 2
#define MsoZOrderCmdmsoSendBackward 3
#define MsoZOrderCmdmsoBringInFrontOfText 4
#define MsoZOrderCmdmsoSendBehindText 5

typedef long MsoSegmentType;
#define MsoSegmentTypemsoSegmentLine 0
#define MsoSegmentTypemsoSegmentCurve 1

typedef long MsoEditingType;
#define MsoEditingTypemsoEditingAuto 0
#define MsoEditingTypemsoEditingCorner 1
#define MsoEditingTypemsoEditingSmooth 2
#define MsoEditingTypemsoEditingSymmetric 3

typedef long MsoAutoShapeType;
#define MsoAutoShapeTypemsoShapeMixed -2
#define MsoAutoShapeTypemsoShapeRectangle 1
#define MsoAutoShapeTypemsoShapeParallelogram 2
#define MsoAutoShapeTypemsoShapeTrapezoid 3
#define MsoAutoShapeTypemsoShapeDiamond 4
#define MsoAutoShapeTypemsoShapeRoundedRectangle 5
#define MsoAutoShapeTypemsoShapeOctagon 6
#define MsoAutoShapeTypemsoShapeIsoscelesTriangle 7
#define MsoAutoShapeTypemsoShapeRightTriangle 8
#define MsoAutoShapeTypemsoShapeOval 9
#define MsoAutoShapeTypemsoShapeHexagon 10
#define MsoAutoShapeTypemsoShapeCross 11
#define MsoAutoShapeTypemsoShapeRegularPentagon 12
#define MsoAutoShapeTypemsoShapeCan 13
#define MsoAutoShapeTypemsoShapeCube 14
#define MsoAutoShapeTypemsoShapeBevel 15
#define MsoAutoShapeTypemsoShapeFoldedCorner 16
#define MsoAutoShapeTypemsoShapeSmileyFace 17
#define MsoAutoShapeTypemsoShapeDonut 18
#define MsoAutoShapeTypemsoShapeNoSymbol 19
#define MsoAutoShapeTypemsoShapeBlockArc 20
#define MsoAutoShapeTypemsoShapeHeart 21
#define MsoAutoShapeTypemsoShapeLightningBolt 22
#define MsoAutoShapeTypemsoShapeSun 23
#define MsoAutoShapeTypemsoShapeMoon 24
#define MsoAutoShapeTypemsoShapeArc 25
#define MsoAutoShapeTypemsoShapeDoubleBracket 26
#define MsoAutoShapeTypemsoShapeDoubleBrace 27
#define MsoAutoShapeTypemsoShapePlaque 28
#define MsoAutoShapeTypemsoShapeLeftBracket 29
#define MsoAutoShapeTypemsoShapeRightBracket 30
#define MsoAutoShapeTypemsoShapeLeftBrace 31
#define MsoAutoShapeTypemsoShapeRightBrace 32
#define MsoAutoShapeTypemsoShapeRightArrow 33
#define MsoAutoShapeTypemsoShapeLeftArrow 34
#define MsoAutoShapeTypemsoShapeUpArrow 35
#define MsoAutoShapeTypemsoShapeDownArrow 36
#define MsoAutoShapeTypemsoShapeLeftRightArrow 37
#define MsoAutoShapeTypemsoShapeUpDownArrow 38
#define MsoAutoShapeTypemsoShapeQuadArrow 39
#define MsoAutoShapeTypemsoShapeLeftRightUpArrow 40
#define MsoAutoShapeTypemsoShapeBentArrow 41
#define MsoAutoShapeTypemsoShapeUTurnArrow 42
#define MsoAutoShapeTypemsoShapeLeftUpArrow 43
#define MsoAutoShapeTypemsoShapeBentUpArrow 44
#define MsoAutoShapeTypemsoShapeCurvedRightArrow 45
#define MsoAutoShapeTypemsoShapeCurvedLeftArrow 46
#define MsoAutoShapeTypemsoShapeCurvedUpArrow 47
#define MsoAutoShapeTypemsoShapeCurvedDownArrow 48
#define MsoAutoShapeTypemsoShapeStripedRightArrow 49
#define MsoAutoShapeTypemsoShapeNotchedRightArrow 50
#define MsoAutoShapeTypemsoShapePentagon 51
#define MsoAutoShapeTypemsoShapeChevron 52
#define MsoAutoShapeTypemsoShapeRightArrowCallout 53
#define MsoAutoShapeTypemsoShapeLeftArrowCallout 54
#define MsoAutoShapeTypemsoShapeUpArrowCallout 55
#define MsoAutoShapeTypemsoShapeDownArrowCallout 56
#define MsoAutoShapeTypemsoShapeLeftRightArrowCallout 57
#define MsoAutoShapeTypemsoShapeUpDownArrowCallout 58
#define MsoAutoShapeTypemsoShapeQuadArrowCallout 59
#define MsoAutoShapeTypemsoShapeCircularArrow 60
#define MsoAutoShapeTypemsoShapeFlowchartProcess 61
#define MsoAutoShapeTypemsoShapeFlowchartAlternateProcess 62
#define MsoAutoShapeTypemsoShapeFlowchartDecision 63
#define MsoAutoShapeTypemsoShapeFlowchartData 64
#define MsoAutoShapeTypemsoShapeFlowchartPredefinedProcess 65
#define MsoAutoShapeTypemsoShapeFlowchartInternalStorage 66
#define MsoAutoShapeTypemsoShapeFlowchartDocument 67
#define MsoAutoShapeTypemsoShapeFlowchartMultidocument 68
#define MsoAutoShapeTypemsoShapeFlowchartTerminator 69
#define MsoAutoShapeTypemsoShapeFlowchartPreparation 70
#define MsoAutoShapeTypemsoShapeFlowchartManualInput 71
#define MsoAutoShapeTypemsoShapeFlowchartManualOperation 72
#define MsoAutoShapeTypemsoShapeFlowchartConnector 73
#define MsoAutoShapeTypemsoShapeFlowchartOffpageConnector 74
#define MsoAutoShapeTypemsoShapeFlowchartCard 75
#define MsoAutoShapeTypemsoShapeFlowchartPunchedTape 76
#define MsoAutoShapeTypemsoShapeFlowchartSummingJunction 77
#define MsoAutoShapeTypemsoShapeFlowchartOr 78
#define MsoAutoShapeTypemsoShapeFlowchartCollate 79
#define MsoAutoShapeTypemsoShapeFlowchartSort 80
#define MsoAutoShapeTypemsoShapeFlowchartExtract 81
#define MsoAutoShapeTypemsoShapeFlowchartMerge 82
#define MsoAutoShapeTypemsoShapeFlowchartStoredData 83
#define MsoAutoShapeTypemsoShapeFlowchartDelay 84
#define MsoAutoShapeTypemsoShapeFlowchartSequentialAccessStorage 85
#define MsoAutoShapeTypemsoShapeFlowchartMagneticDisk 86
#define MsoAutoShapeTypemsoShapeFlowchartDirectAccessStorage 87
#define MsoAutoShapeTypemsoShapeFlowchartDisplay 88
#define MsoAutoShapeTypemsoShapeExplosion1 89
#define MsoAutoShapeTypemsoShapeExplosion2 90
#define MsoAutoShapeTypemsoShape4pointStar 91
#define MsoAutoShapeTypemsoShape5pointStar 92
#define MsoAutoShapeTypemsoShape8pointStar 93
#define MsoAutoShapeTypemsoShape16pointStar 94
#define MsoAutoShapeTypemsoShape24pointStar 95
#define MsoAutoShapeTypemsoShape32pointStar 96
#define MsoAutoShapeTypemsoShapeUpRibbon 97
#define MsoAutoShapeTypemsoShapeDownRibbon 98
#define MsoAutoShapeTypemsoShapeCurvedUpRibbon 99
#define MsoAutoShapeTypemsoShapeCurvedDownRibbon 100
#define MsoAutoShapeTypemsoShapeVerticalScroll 101
#define MsoAutoShapeTypemsoShapeHorizontalScroll 102
#define MsoAutoShapeTypemsoShapeWave 103
#define MsoAutoShapeTypemsoShapeDoubleWave 104
#define MsoAutoShapeTypemsoShapeRectangularCallout 105
#define MsoAutoShapeTypemsoShapeRoundedRectangularCallout 106
#define MsoAutoShapeTypemsoShapeOvalCallout 107
#define MsoAutoShapeTypemsoShapeCloudCallout 108
#define MsoAutoShapeTypemsoShapeLineCallout1 109
#define MsoAutoShapeTypemsoShapeLineCallout2 110
#define MsoAutoShapeTypemsoShapeLineCallout3 111
#define MsoAutoShapeTypemsoShapeLineCallout4 112
#define MsoAutoShapeTypemsoShapeLineCallout1AccentBar 113
#define MsoAutoShapeTypemsoShapeLineCallout2AccentBar 114
#define MsoAutoShapeTypemsoShapeLineCallout3AccentBar 115
#define MsoAutoShapeTypemsoShapeLineCallout4AccentBar 116
#define MsoAutoShapeTypemsoShapeLineCallout1NoBorder 117
#define MsoAutoShapeTypemsoShapeLineCallout2NoBorder 118
#define MsoAutoShapeTypemsoShapeLineCallout3NoBorder 119
#define MsoAutoShapeTypemsoShapeLineCallout4NoBorder 120
#define MsoAutoShapeTypemsoShapeLineCallout1BorderandAccentBar 121
#define MsoAutoShapeTypemsoShapeLineCallout2BorderandAccentBar 122
#define MsoAutoShapeTypemsoShapeLineCallout3BorderandAccentBar 123
#define MsoAutoShapeTypemsoShapeLineCallout4BorderandAccentBar 124
#define MsoAutoShapeTypemsoShapeActionButtonCustom 125
#define MsoAutoShapeTypemsoShapeActionButtonHome 126
#define MsoAutoShapeTypemsoShapeActionButtonHelp 127
#define MsoAutoShapeTypemsoShapeActionButtonInformation 128
#define MsoAutoShapeTypemsoShapeActionButtonBackorPrevious 129
#define MsoAutoShapeTypemsoShapeActionButtonForwardorNext 130
#define MsoAutoShapeTypemsoShapeActionButtonBeginning 131
#define MsoAutoShapeTypemsoShapeActionButtonEnd 132
#define MsoAutoShapeTypemsoShapeActionButtonReturn 133
#define MsoAutoShapeTypemsoShapeActionButtonDocument 134
#define MsoAutoShapeTypemsoShapeActionButtonSound 135
#define MsoAutoShapeTypemsoShapeActionButtonMovie 136
#define MsoAutoShapeTypemsoShapeBalloon 137
#define MsoAutoShapeTypemsoShapeNotPrimitive 138

typedef long MsoShapeType;
#define MsoShapeTypemsoShapeTypeMixed -2
#define MsoShapeTypemsoAutoShape 1
#define MsoShapeTypemsoCallout 2
#define MsoShapeTypemsoChart 3
#define MsoShapeTypemsoComment 4
#define MsoShapeTypemsoFreeform 5
#define MsoShapeTypemsoGroup 6
#define MsoShapeTypemsoEmbeddedOLEObject 7
#define MsoShapeTypemsoFormControl 8
#define MsoShapeTypemsoLine 9
#define MsoShapeTypemsoLinkedOLEObject 10
#define MsoShapeTypemsoLinkedPicture 11
#define MsoShapeTypemsoOLEControlObject 12
#define MsoShapeTypemsoPicture 13
#define MsoShapeTypemsoPlaceholder 14
#define MsoShapeTypemsoTextEffect 15
#define MsoShapeTypemsoMedia 16
#define MsoShapeTypemsoTextBox 17

typedef long MsoFlipCmd;
#define MsoFlipCmdmsoFlipHorizontal 0
#define MsoFlipCmdmsoFlipVertical 1

typedef long MsoTriState;
#define MsoTriStatemsoTrue -1
#define MsoTriStatemsoFalse 0
#define MsoTriStatemsoCTrue 1
#define MsoTriStatemsoTriStateToggle -3
#define MsoTriStatemsoTriStateMixed -2

typedef long MsoColorType;
#define MsoColorTypemsoColorTypeMixed -2
#define MsoColorTypemsoColorTypeRGB 1
#define MsoColorTypemsoColorTypeScheme 2

typedef long MsoPictureColorType;
#define MsoPictureColorTypemsoPictureMixed -2
#define MsoPictureColorTypemsoPictureAutomatic 1
#define MsoPictureColorTypemsoPictureGrayscale 2
#define MsoPictureColorTypemsoPictureBlackAndWhite 3
#define MsoPictureColorTypemsoPictureWatermark 4

typedef long MsoCalloutAngleType;
#define MsoCalloutAngleTypemsoCalloutAngleMixed -2
#define MsoCalloutAngleTypemsoCalloutAngleAutomatic 1
#define MsoCalloutAngleTypemsoCalloutAngle30 2
#define MsoCalloutAngleTypemsoCalloutAngle45 3
#define MsoCalloutAngleTypemsoCalloutAngle60 4
#define MsoCalloutAngleTypemsoCalloutAngle90 5

typedef long MsoCalloutDropType;
#define MsoCalloutDropTypemsoCalloutDropMixed -2
#define MsoCalloutDropTypemsoCalloutDropCustom 1
#define MsoCalloutDropTypemsoCalloutDropTop 2
#define MsoCalloutDropTypemsoCalloutDropCenter 3
#define MsoCalloutDropTypemsoCalloutDropBottom 4

typedef long MsoCalloutType;
#define MsoCalloutTypemsoCalloutMixed -2
#define MsoCalloutTypemsoCalloutOne 1
#define MsoCalloutTypemsoCalloutTwo 2
#define MsoCalloutTypemsoCalloutThree 3
#define MsoCalloutTypemsoCalloutFour 4

typedef long MsoBlackWhiteMode;
#define MsoBlackWhiteModemsoBlackWhiteMixed -2
#define MsoBlackWhiteModemsoBlackWhiteAutomatic 1
#define MsoBlackWhiteModemsoBlackWhiteGrayScale 2
#define MsoBlackWhiteModemsoBlackWhiteLightGrayScale 3
#define MsoBlackWhiteModemsoBlackWhiteInverseGrayScale 4
#define MsoBlackWhiteModemsoBlackWhiteGrayOutline 5
#define MsoBlackWhiteModemsoBlackWhiteBlackTextAndLine 6
#define MsoBlackWhiteModemsoBlackWhiteHighContrast 7
#define MsoBlackWhiteModemsoBlackWhiteBlack 8
#define MsoBlackWhiteModemsoBlackWhiteWhite 9
#define MsoBlackWhiteModemsoBlackWhiteDontShow 10

typedef long MsoMixedType;
#define MsoMixedTypemsoIntegerMixed -32768
#define MsoMixedTypemsoSingleMixed 0

typedef long MsoTextOrientation;
#define MsoTextOrientationmsoTextOrientationMixed -2
#define MsoTextOrientationmsoTextOrientationHorizontal 1
#define MsoTextOrientationmsoTextOrientationUpward 2
#define MsoTextOrientationmsoTextOrientationDownward 3
#define MsoTextOrientationmsoTextOrientationVerticalFarEast 4
#define MsoTextOrientationmsoTextOrientationVertical 5
#define MsoTextOrientationmsoTextOrientationHorizontalRotatedFarEast 6

typedef long MsoScaleFrom;
#define MsoScaleFrommsoScaleFromTopLeft 0
#define MsoScaleFrommsoScaleFromMiddle 1
#define MsoScaleFrommsoScaleFromBottomRight 2

typedef long MsoBarPosition;
#define MsoBarPositionmsoBarLeft 0
#define MsoBarPositionmsoBarTop 1
#define MsoBarPositionmsoBarRight 2
#define MsoBarPositionmsoBarBottom 3
#define MsoBarPositionmsoBarFloating 4
#define MsoBarPositionmsoBarPopup 5
#define MsoBarPositionmsoBarMenuBar 6

typedef long MsoBarProtection;
#define MsoBarProtectionmsoBarNoProtection 0
#define MsoBarProtectionmsoBarNoCustomize 1
#define MsoBarProtectionmsoBarNoResize 2
#define MsoBarProtectionmsoBarNoMove 4
#define MsoBarProtectionmsoBarNoChangeVisible 8
#define MsoBarProtectionmsoBarNoChangeDock 16
#define MsoBarProtectionmsoBarNoVerticalDock 32
#define MsoBarProtectionmsoBarNoHorizontalDock 64

typedef long MsoBarType;
#define MsoBarTypemsoBarTypeNormal 0
#define MsoBarTypemsoBarTypeMenuBar 1
#define MsoBarTypemsoBarTypePopup 2

typedef long MsoControlType;
#define MsoControlTypemsoControlCustom 0
#define MsoControlTypemsoControlButton 1
#define MsoControlTypemsoControlEdit 2
#define MsoControlTypemsoControlDropdown 3
#define MsoControlTypemsoControlComboBox 4
#define MsoControlTypemsoControlButtonDropdown 5
#define MsoControlTypemsoControlSplitDropdown 6
#define MsoControlTypemsoControlOCXDropdown 7
#define MsoControlTypemsoControlGenericDropdown 8
#define MsoControlTypemsoControlGraphicDropdown 9
#define MsoControlTypemsoControlPopup 10
#define MsoControlTypemsoControlGraphicPopup 11
#define MsoControlTypemsoControlButtonPopup 12
#define MsoControlTypemsoControlSplitButtonPopup 13
#define MsoControlTypemsoControlSplitButtonMRUPopup 14
#define MsoControlTypemsoControlLabel 15
#define MsoControlTypemsoControlExpandingGrid 16
#define MsoControlTypemsoControlSplitExpandingGrid 17
#define MsoControlTypemsoControlGrid 18
#define MsoControlTypemsoControlGauge 19
#define MsoControlTypemsoControlGraphicCombo 20

typedef long MsoButtonState;
#define MsoButtonStatemsoButtonUp 0
#define MsoButtonStatemsoButtonDown -1
#define MsoButtonStatemsoButtonMixed 2

typedef long MsoControlOLEUsage;
#define MsoControlOLEUsagemsoControlOLEUsageNeither 0
#define MsoControlOLEUsagemsoControlOLEUsageServer 1
#define MsoControlOLEUsagemsoControlOLEUsageClient 2
#define MsoControlOLEUsagemsoControlOLEUsageBoth 3

typedef long MsoButtonStyle;
#define MsoButtonStylemsoButtonAutomatic 0
#define MsoButtonStylemsoButtonIcon 1
#define MsoButtonStylemsoButtonCaption 2
#define MsoButtonStylemsoButtonIconAndCaption 3

typedef long MsoComboStyle;
#define MsoComboStylemsoComboNormal 0
#define MsoComboStylemsoComboLabel 1

typedef long MsoOLEMenuGroup;
#define MsoOLEMenuGroupmsoOLEMenuGroupNone -1
#define MsoOLEMenuGroupmsoOLEMenuGroupFile 0
#define MsoOLEMenuGroupmsoOLEMenuGroupEdit 1
#define MsoOLEMenuGroupmsoOLEMenuGroupContainer 2
#define MsoOLEMenuGroupmsoOLEMenuGroupObject 3
#define MsoOLEMenuGroupmsoOLEMenuGroupWindow 4
#define MsoOLEMenuGroupmsoOLEMenuGroupHelp 5

typedef long MsoMenuAnimation;
#define MsoMenuAnimationmsoMenuAnimationNone 0
#define MsoMenuAnimationmsoMenuAnimationRandom 1
#define MsoMenuAnimationmsoMenuAnimationUnfold 2
#define MsoMenuAnimationmsoMenuAnimationSlide 3

typedef long MsoBarRow;
#define MsoBarRowmsoBarRowFirst 0
#define MsoBarRowmsoBarRowLast -1

typedef long MsoHyperlinkType;
#define MsoHyperlinkTypemsoHyperlinkRange 0
#define MsoHyperlinkTypemsoHyperlinkShape 1
#define MsoHyperlinkTypemsoHyperlinkInlineShape 2

typedef long MsoExtraInfoMethod;
#define MsoExtraInfoMethodmsoMethodGet 0
#define MsoExtraInfoMethodmsoMethodPost 1

typedef long MsoAnimationType;
#define MsoAnimationTypemsoAnimationIdle 1
#define MsoAnimationTypemsoAnimationGreeting 2
#define MsoAnimationTypemsoAnimationGoodbye 3
#define MsoAnimationTypemsoAnimationBeginSpeaking 4
#define MsoAnimationTypemsoAnimationCharacterSuccessMajor 6
#define MsoAnimationTypemsoAnimationGetAttentionMajor 11
#define MsoAnimationTypemsoAnimationGetAttentionMinor 12
#define MsoAnimationTypemsoAnimationSearching 13
#define MsoAnimationTypemsoAnimationPrinting 18
#define MsoAnimationTypemsoAnimationGestureRight 19
#define MsoAnimationTypemsoAnimationWritingNotingSomething 22
#define MsoAnimationTypemsoAnimationWorkingAtSomething 23
#define MsoAnimationTypemsoAnimationThinking 24
#define MsoAnimationTypemsoAnimationSendingMail 25
#define MsoAnimationTypemsoAnimationListensToComputer 26
#define MsoAnimationTypemsoAnimationDisappear 31
#define MsoAnimationTypemsoAnimationAppear 32
#define MsoAnimationTypemsoAnimationGetArtsy 100
#define MsoAnimationTypemsoAnimationGetTechy 101
#define MsoAnimationTypemsoAnimationGetWizardy 102
#define MsoAnimationTypemsoAnimationCheckingSomething 103
#define MsoAnimationTypemsoAnimationLookDown 104
#define MsoAnimationTypemsoAnimationLookDownLeft 105
#define MsoAnimationTypemsoAnimationLookDownRight 106
#define MsoAnimationTypemsoAnimationLookLeft 107
#define MsoAnimationTypemsoAnimationLookRight 108
#define MsoAnimationTypemsoAnimationLookUp 109
#define MsoAnimationTypemsoAnimationLookUpLeft 110
#define MsoAnimationTypemsoAnimationLookUpRight 111
#define MsoAnimationTypemsoAnimationSaving 112
#define MsoAnimationTypemsoAnimationGestureDown 113
#define MsoAnimationTypemsoAnimationGestureLeft 114
#define MsoAnimationTypemsoAnimationGestureUp 115
#define MsoAnimationTypemsoAnimationEmptyTrash 116

typedef long MsoButtonSetType;
#define MsoButtonSetTypemsoButtonSetNone 0
#define MsoButtonSetTypemsoButtonSetOK 1
#define MsoButtonSetTypemsoButtonSetCancel 2
#define MsoButtonSetTypemsoButtonSetOkCancel 3
#define MsoButtonSetTypemsoButtonSetYesNo 4
#define MsoButtonSetTypemsoButtonSetYesNoCancel 5
#define MsoButtonSetTypemsoButtonSetBackClose 6
#define MsoButtonSetTypemsoButtonSetNextClose 7
#define MsoButtonSetTypemsoButtonSetBackNextClose 8
#define MsoButtonSetTypemsoButtonSetRetryCancel 9
#define MsoButtonSetTypemsoButtonSetAbortRetryIgnore 10
#define MsoButtonSetTypemsoButtonSetSearchClose 11
#define MsoButtonSetTypemsoButtonSetBackNextSnooze 12
#define MsoButtonSetTypemsoButtonSetTipsOptionsClose 13
#define MsoButtonSetTypemsoButtonSetYesAllNoCancel 14

typedef long MsoIconType;
#define MsoIconTypemsoIconNone 0
#define MsoIconTypemsoIconAlert 2
#define MsoIconTypemsoIconTip 3

typedef long MsoBalloonType;
#define MsoBalloonTypemsoBalloonTypeButtons 0
#define MsoBalloonTypemsoBalloonTypeBullets 1
#define MsoBalloonTypemsoBalloonTypeNumbers 2

typedef long MsoModeType;
#define MsoModeTypemsoModeModal 0
#define MsoModeTypemsoModeAutoDown 1
#define MsoModeTypemsoModeModeless 2

typedef long MsoBalloonErrorType;
#define MsoBalloonErrorTypemsoBalloonErrorNone 0
#define MsoBalloonErrorTypemsoBalloonErrorOther 1
#define MsoBalloonErrorTypemsoBalloonErrorTooBig 2
#define MsoBalloonErrorTypemsoBalloonErrorOutOfMemory 3
#define MsoBalloonErrorTypemsoBalloonErrorBadPictureRef 4
#define MsoBalloonErrorTypemsoBalloonErrorBadReference 5
#define MsoBalloonErrorTypemsoBalloonErrorButtonlessModal 6
#define MsoBalloonErrorTypemsoBalloonErrorButtonModeless 7
#define MsoBalloonErrorTypemsoBalloonErrorBadCharacter 8

typedef long MsoWizardActType;
#define MsoWizardActTypemsoWizardActInactive 0
#define MsoWizardActTypemsoWizardActActive 1
#define MsoWizardActTypemsoWizardActSuspend 2
#define MsoWizardActTypemsoWizardActResume 3

typedef long MsoWizardMsgType;
#define MsoWizardMsgTypemsoWizardMsgLocalStateOn 1
#define MsoWizardMsgTypemsoWizardMsgLocalStateOff 2
#define MsoWizardMsgTypemsoWizardMsgShowHelp 3
#define MsoWizardMsgTypemsoWizardMsgSuspending 4
#define MsoWizardMsgTypemsoWizardMsgResuming 5

typedef long MsoBalloonButtonType;
#define MsoBalloonButtonTypemsoBalloonButtonYesToAll -15
#define MsoBalloonButtonTypemsoBalloonButtonOptions -14
#define MsoBalloonButtonTypemsoBalloonButtonTips -13
#define MsoBalloonButtonTypemsoBalloonButtonClose -12
#define MsoBalloonButtonTypemsoBalloonButtonSnooze -11
#define MsoBalloonButtonTypemsoBalloonButtonSearch -10
#define MsoBalloonButtonTypemsoBalloonButtonIgnore -9
#define MsoBalloonButtonTypemsoBalloonButtonAbort -8
#define MsoBalloonButtonTypemsoBalloonButtonRetry -7
#define MsoBalloonButtonTypemsoBalloonButtonNext -6
#define MsoBalloonButtonTypemsoBalloonButtonBack -5
#define MsoBalloonButtonTypemsoBalloonButtonNo -4
#define MsoBalloonButtonTypemsoBalloonButtonYes -3
#define MsoBalloonButtonTypemsoBalloonButtonCancel -2
#define MsoBalloonButtonTypemsoBalloonButtonOK -1
#define MsoBalloonButtonTypemsoBalloonButtonNull 0

typedef long MsoDocProperties;
#define MsoDocPropertiesmsoPropertyTypeNumber 1
#define MsoDocPropertiesmsoPropertyTypeBoolean 2
#define MsoDocPropertiesmsoPropertyTypeDate 3
#define MsoDocPropertiesmsoPropertyTypeString 4
#define MsoDocPropertiesmsoPropertyTypeFloat 5

typedef long MsoFileFindOptions;
#define MsoFileFindOptionsmsoOptionsNew 1
#define MsoFileFindOptionsmsoOptionsAdd 2
#define MsoFileFindOptionsmsoOptionsWithin 3

typedef long MsoFileFindView;
#define MsoFileFindViewmsoViewFileInfo 1
#define MsoFileFindViewmsoViewPreview 2
#define MsoFileFindViewmsoViewSummaryInfo 3

typedef long MsoFileFindSortBy;
#define MsoFileFindSortBymsoFileFindSortbyAuthor 1
#define MsoFileFindSortBymsoFileFindSortbyDateCreated 2
#define MsoFileFindSortBymsoFileFindSortbyLastSavedBy 3
#define MsoFileFindSortBymsoFileFindSortbyDateSaved 4
#define MsoFileFindSortBymsoFileFindSortbyFileName 5
#define MsoFileFindSortBymsoFileFindSortbySize 6
#define MsoFileFindSortBymsoFileFindSortbyTitle 7

typedef long MsoFileFindListBy;
#define MsoFileFindListBymsoListbyName 1
#define MsoFileFindListBymsoListbyTitle 2

typedef long MsoLastModified;
#define MsoLastModifiedmsoLastModifiedYesterday 1
#define MsoLastModifiedmsoLastModifiedToday 2
#define MsoLastModifiedmsoLastModifiedLastWeek 3
#define MsoLastModifiedmsoLastModifiedThisWeek 4
#define MsoLastModifiedmsoLastModifiedLastMonth 5
#define MsoLastModifiedmsoLastModifiedThisMonth 6
#define MsoLastModifiedmsoLastModifiedAnyTime 7

typedef long MsoSortBy;
#define MsoSortBymsoSortByFileName 1
#define MsoSortBymsoSortBySize 2
#define MsoSortBymsoSortByFileType 3
#define MsoSortBymsoSortByLastModified 4

typedef long MsoSortOrder;
#define MsoSortOrdermsoSortOrderAscending 1
#define MsoSortOrdermsoSortOrderDescending 2

typedef long MsoConnector;
#define MsoConnectormsoConnectorAnd 1
#define MsoConnectormsoConnectorOr 2

typedef long MsoCondition;
#define MsoConditionmsoConditionFileTypeAllFiles 1
#define MsoConditionmsoConditionFileTypeOfficeFiles 2
#define MsoConditionmsoConditionFileTypeWordDocuments 3
#define MsoConditionmsoConditionFileTypeExcelWorkbooks 4
#define MsoConditionmsoConditionFileTypePowerPointPresentations 5
#define MsoConditionmsoConditionFileTypeBinders 6
#define MsoConditionmsoConditionFileTypeDatabases 7
#define MsoConditionmsoConditionFileTypeTemplates 8
#define MsoConditionmsoConditionIncludes 9
#define MsoConditionmsoConditionIncludesPhrase 10
#define MsoConditionmsoConditionBeginsWith 11
#define MsoConditionmsoConditionEndsWith 12
#define MsoConditionmsoConditionIncludesNearEachOther 13
#define MsoConditionmsoConditionIsExactly 14
#define MsoConditionmsoConditionIsNot 15
#define MsoConditionmsoConditionYesterday 16
#define MsoConditionmsoConditionToday 17
#define MsoConditionmsoConditionTomorrow 18
#define MsoConditionmsoConditionLastWeek 19
#define MsoConditionmsoConditionThisWeek 20
#define MsoConditionmsoConditionNextWeek 21
#define MsoConditionmsoConditionLastMonth 22
#define MsoConditionmsoConditionThisMonth 23
#define MsoConditionmsoConditionNextMonth 24
#define MsoConditionmsoConditionAnytime 25
#define MsoConditionmsoConditionAnytimeBetween 26
#define MsoConditionmsoConditionOn 27
#define MsoConditionmsoConditionOnOrAfter 28
#define MsoConditionmsoConditionOnOrBefore 29
#define MsoConditionmsoConditionInTheNext 30
#define MsoConditionmsoConditionInTheLast 31
#define MsoConditionmsoConditionEquals 32
#define MsoConditionmsoConditionDoesNotEqual 33
#define MsoConditionmsoConditionAnyNumberBetween 34
#define MsoConditionmsoConditionAtMost 35
#define MsoConditionmsoConditionAtLeast 36
#define MsoConditionmsoConditionMoreThan 37
#define MsoConditionmsoConditionLessThan 38
#define MsoConditionmsoConditionIsYes 39
#define MsoConditionmsoConditionIsNo 40

typedef long MsoFileType;
#define MsoFileTypemsoFileTypeAllFiles 1
#define MsoFileTypemsoFileTypeOfficeFiles 2
#define MsoFileTypemsoFileTypeWordDocuments 3
#define MsoFileTypemsoFileTypeExcelWorkbooks 4
#define MsoFileTypemsoFileTypePowerPointPresentations 5
#define MsoFileTypemsoFileTypeBinders 6
#define MsoFileTypemsoFileTypeDatabases 7
#define MsoFileTypemsoFileTypeTemplates 8

class _DualCommandBars;
class _CommandBars;
class _DualCommandBar;
class _CommandBar;
class _DualCommandBarControls;
class _CommandBarControls;
class _DualCommandBarControl;
class _CommandBarControl;
class _DualCommandBarButton;
class _CommandBarButton;
class _DualCommandBarPopup;
class _CommandBarPopup;
class _DualCommandBarComboBox;
class _CommandBarComboBox;
class _DualAssistant;
class _Assistant;
class _DualBalloon;
class _Balloon;
class _DualBalloonCheckboxes;
class _BalloonCheckboxes;
class _DualBalloonCheckbox;
class _BalloonCheckbox;
class _DualBalloonLabels;
class _BalloonLabels;
class _DualBalloonLabel;
class _BalloonLabel;
class DocumentProperty;
class DocumentProperties;
class _DualIFoundFiles;
class _IFoundFiles;
class _DualIFind;
class _IFind;
class _DualFoundFiles;
class _FoundFiles;
class _DualPropertyTest;
class _PropertyTest;
class _DualPropertyTests;
class _PropertyTests;
class _DualFileSearch;
class _FileSearch;

typedef long MsoRGBType;

class __stdcall _DualCommandBars : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetApplication( WPIDispatch * __resultApplication ) = 0;
        virtual WHRESULT GetCreator( long * __resultCreator ) = 0;
        virtual WHRESULT GetActionControl( _DualCommandBarControl * * __resultActionControl ) = 0;
        virtual WHRESULT GetActiveMenuBar( _DualCommandBar * * __resultActiveMenuBar ) = 0;
        virtual WHRESULT Add( WVARIANT __Name=WVariant(), WVARIANT __Position=WVariant(), WVARIANT __MenuBar=WVariant(), WVARIANT __Temporary=WVariant(), _DualCommandBar * * __resultAdd=NULL ) = 0;
        virtual WHRESULT GetCount( int * __resultCount ) = 0;
        virtual WHRESULT GetDisplayTooltips( WVARIANT_BOOL * __resultDisplayTooltips ) = 0;
        virtual WHRESULT SetDisplayTooltips( WVARIANT_BOOL __DisplayTooltips ) = 0;
        virtual WHRESULT GetDisplayKeysInTooltips( WVARIANT_BOOL * __resultDisplayKeysInTooltips ) = 0;
        virtual WHRESULT SetDisplayKeysInTooltips( WVARIANT_BOOL __DisplayKeysInTooltips ) = 0;
        virtual WHRESULT FindControl( WVARIANT __Type=WVariant(), WVARIANT __Id=WVariant(), WVARIANT __Tag=WVariant(), WVARIANT __Visible=WVariant(), _DualCommandBarControl * * __resultFindControl=NULL ) = 0;
        virtual WHRESULT GetItem( WVARIANT __Index, _DualCommandBar * * __resultItem ) = 0;
        virtual WHRESULT GetLargeButtons( WVARIANT_BOOL * __resultLargeButtons ) = 0;
        virtual WHRESULT SetLargeButtons( WVARIANT_BOOL __LargeButtons ) = 0;
        virtual WHRESULT GetMenuAnimationStyle( MsoMenuAnimation * __resultMenuAnimationStyle ) = 0;
        virtual WHRESULT SetMenuAnimationStyle( MsoMenuAnimation __MenuAnimationStyle ) = 0;
        virtual WHRESULT Get_NewEnum( WPIUnknown * __result_NewEnum ) = 0;
        virtual WHRESULT GetParent( WPIDispatch * __resultParent ) = 0;
        virtual WHRESULT ReleaseFocus( void ) = 0;
};

class _CommandBars : public WOleDispatchHelper {

    public:

        _CommandBars();
        ~_CommandBars();

        /* Methods */
        WPIDispatch GetApplication( void );
        long GetCreator( void );
        _DualCommandBarControl * GetActionControl( void );
        _DualCommandBar * GetActiveMenuBar( void );
        _DualCommandBar * Add( WVariant __Name=WVariant(), WVariant __Position=WVariant(), WVariant __MenuBar=WVariant(), WVariant __Temporary=WVariant() );
        int GetCount( void );
        WVARIANT_BOOL GetDisplayTooltips( void );
        void SetDisplayTooltips( WVARIANT_BOOL __DisplayTooltips );
        WVARIANT_BOOL GetDisplayKeysInTooltips( void );
        void SetDisplayKeysInTooltips( WVARIANT_BOOL __DisplayKeysInTooltips );
        _DualCommandBarControl * FindControl( WVariant __Type=WVariant(), WVariant __Id=WVariant(), WVariant __Tag=WVariant(), WVariant __Visible=WVariant() );
        _DualCommandBar * GetItem( WVariant __Index );
        WVARIANT_BOOL GetLargeButtons( void );
        void SetLargeButtons( WVARIANT_BOOL __LargeButtons );
        MsoMenuAnimation GetMenuAnimationStyle( void );
        void SetMenuAnimationStyle( MsoMenuAnimation __MenuAnimationStyle );
        WPIUnknown Get_NewEnum( void );
        WPIDispatch GetParent( void );
        void ReleaseFocus( void );

        _CommandBars & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _CommandBars & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualCommandBar : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetaccParent( WPIDispatch * __resultaccParent ) = 0;
        virtual WHRESULT GetaccChildCount( long * __resultaccChildCount ) = 0;
        virtual WHRESULT GetaccChild( WVARIANT __varChild, WPIDispatch * __resultaccChild ) = 0;
        virtual WHRESULT GetaccName( WVARIANT __varChild=WVariant(), WBStr * __resultaccName=NULL ) = 0;
        virtual WHRESULT GetaccValue( WVARIANT __varChild=WVariant(), WBStr * __resultaccValue=NULL ) = 0;
        virtual WHRESULT GetaccDescription( WVARIANT __varChild=WVariant(), WBStr * __resultaccDescription=NULL ) = 0;
        virtual WHRESULT GetaccRole( WVARIANT __varChild=WVariant(), WVARIANT * __resultaccRole=NULL ) = 0;
        virtual WHRESULT GetaccState( WVARIANT __varChild=WVariant(), WVARIANT * __resultaccState=NULL ) = 0;
        virtual WHRESULT GetaccHelp( WVARIANT __varChild=WVariant(), WBStr * __resultaccHelp=NULL ) = 0;
        virtual WHRESULT GetaccHelpTopic( WBStr * __pszHelpFile, WVARIANT __varChild=WVariant(), long * __resultaccHelpTopic=NULL ) = 0;
        virtual WHRESULT GetaccKeyboardShortcut( WVARIANT __varChild=WVariant(), WBStr * __resultaccKeyboardShortcut=NULL ) = 0;
        virtual WHRESULT GetaccFocus( WVARIANT * __resultaccFocus ) = 0;
        virtual WHRESULT GetaccSelection( WVARIANT * __resultaccSelection ) = 0;
        virtual WHRESULT GetaccDefaultAction( WVARIANT __varChild=WVariant(), WBStr * __resultaccDefaultAction=NULL ) = 0;
        virtual WHRESULT accSelect( long __flagsSelect, WVARIANT __varChild=WVariant() ) = 0;
        virtual WHRESULT accLocation( long * __pxLeft, long * __pyTop, long * __pcxWidth, long * __pcyHeight, WVARIANT __varChild=WVariant() ) = 0;
        virtual WHRESULT accNavigate( long __navDir, WVARIANT __varStart=WVariant(), WVARIANT * __resultaccNavigate=NULL ) = 0;
        virtual WHRESULT accHitTest( long __xLeft, long __yTop, WVARIANT * __resultaccHitTest ) = 0;
        virtual WHRESULT accDoDefaultAction( WVARIANT __varChild=WVariant() ) = 0;
        virtual WHRESULT SetaccName( WVARIANT __varChild, WBStr __accName ) = 0;
        virtual WHRESULT SetaccValue( WVARIANT __varChild, WBStr __accValue ) = 0;
        virtual WHRESULT GetApplication( WPIDispatch * __resultApplication ) = 0;
        virtual WHRESULT GetCreator( long * __resultCreator ) = 0;
        virtual WHRESULT GetBuiltIn( WVARIANT_BOOL * __resultBuiltIn ) = 0;
        virtual WHRESULT GetContext( WBStr * __resultContext ) = 0;
        virtual WHRESULT SetContext( WBStr __Context ) = 0;
        virtual WHRESULT GetControls( _DualCommandBarControls * * __resultControls ) = 0;
        virtual WHRESULT Delete( void ) = 0;
        virtual WHRESULT GetEnabled( WVARIANT_BOOL * __resultEnabled ) = 0;
        virtual WHRESULT SetEnabled( WVARIANT_BOOL __Enabled ) = 0;
        virtual WHRESULT FindControl( WVARIANT __Type=WVariant(), WVARIANT __Id=WVariant(), WVARIANT __Tag=WVariant(), WVARIANT __Visible=WVariant(), WVARIANT __Recursive=WVariant(), _DualCommandBarControl * * __resultFindControl=NULL ) = 0;
        virtual WHRESULT GetHeight( int * __resultHeight ) = 0;
        virtual WHRESULT SetHeight( int __Height ) = 0;
        virtual WHRESULT GetIndex( int * __resultIndex ) = 0;
        virtual WHRESULT GetInstanceId( long * __resultInstanceId ) = 0;
        virtual WHRESULT GetLeft( int * __resultLeft ) = 0;
        virtual WHRESULT SetLeft( int __Left ) = 0;
        virtual WHRESULT GetName( WBStr * __resultName ) = 0;
        virtual WHRESULT SetName( WBStr __Name ) = 0;
        virtual WHRESULT GetNameLocal( WBStr * __resultNameLocal ) = 0;
        virtual WHRESULT SetNameLocal( WBStr __NameLocal ) = 0;
        virtual WHRESULT GetParent( WPIDispatch * __resultParent ) = 0;
        virtual WHRESULT GetPosition( MsoBarPosition * __resultPosition ) = 0;
        virtual WHRESULT SetPosition( MsoBarPosition __Position ) = 0;
        virtual WHRESULT GetRowIndex( int * __resultRowIndex ) = 0;
        virtual WHRESULT SetRowIndex( int __RowIndex ) = 0;
        virtual WHRESULT GetProtection( MsoBarProtection * __resultProtection ) = 0;
        virtual WHRESULT SetProtection( MsoBarProtection __Protection ) = 0;
        virtual WHRESULT Reset( void ) = 0;
        virtual WHRESULT ShowPopup( WVARIANT __x=WVariant(), WVARIANT __y=WVariant() ) = 0;
        virtual WHRESULT GetTop( int * __resultTop ) = 0;
        virtual WHRESULT SetTop( int __Top ) = 0;
        virtual WHRESULT GetType( MsoBarType * __resultType ) = 0;
        virtual WHRESULT GetVisible( WVARIANT_BOOL * __resultVisible ) = 0;
        virtual WHRESULT SetVisible( WVARIANT_BOOL __Visible ) = 0;
        virtual WHRESULT GetWidth( int * __resultWidth ) = 0;
        virtual WHRESULT SetWidth( int __Width ) = 0;
};

class _CommandBar : public WOleDispatchHelper {

    public:

        _CommandBar();
        ~_CommandBar();

        /* Methods */
        WPIDispatch GetApplication( void );
        long GetCreator( void );
        WVARIANT_BOOL GetBuiltIn( void );
        WBString GetContext( void );
        void SetContext( WBString __Context );
        _DualCommandBarControls * GetControls( void );
        void Delete( void );
        WVARIANT_BOOL GetEnabled( void );
        void SetEnabled( WVARIANT_BOOL __Enabled );
        _DualCommandBarControl * FindControl( WVariant __Type=WVariant(), WVariant __Id=WVariant(), WVariant __Tag=WVariant(), WVariant __Visible=WVariant(), WVariant __Recursive=WVariant() );
        int GetHeight( void );
        void SetHeight( int __Height );
        int GetIndex( void );
        int GetLeft( void );
        void SetLeft( int __Left );
        WBString GetName( void );
        void SetName( WBString __Name );
        WBString GetNameLocal( void );
        void SetNameLocal( WBString __NameLocal );
        WPIDispatch GetParent( void );
        MsoBarPosition GetPosition( void );
        void SetPosition( MsoBarPosition __Position );
        int GetRowIndex( void );
        void SetRowIndex( int __RowIndex );
        MsoBarProtection GetProtection( void );
        void SetProtection( MsoBarProtection __Protection );
        void Reset( void );
        void ShowPopup( WVariant __x=WVariant(), WVariant __y=WVariant() );
        int GetTop( void );
        void SetTop( int __Top );
        MsoBarType GetType( void );
        WVARIANT_BOOL GetVisible( void );
        void SetVisible( WVARIANT_BOOL __Visible );
        int GetWidth( void );
        void SetWidth( int __Width );

        _CommandBar & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _CommandBar & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualCommandBarControls : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetApplication( WPIDispatch * __resultApplication ) = 0;
        virtual WHRESULT GetCreator( long * __resultCreator ) = 0;
        virtual WHRESULT Add( WVARIANT __Type=WVariant(), WVARIANT __Id=WVariant(), WVARIANT __Parameter=WVariant(), WVARIANT __Before=WVariant(), WVARIANT __Temporary=WVariant(), _DualCommandBarControl * * __resultAdd=NULL ) = 0;
        virtual WHRESULT GetCount( int * __resultCount ) = 0;
        virtual WHRESULT GetItem( WVARIANT __Index, _DualCommandBarControl * * __resultItem ) = 0;
        virtual WHRESULT Get_NewEnum( WPIUnknown * __result_NewEnum ) = 0;
        virtual WHRESULT GetParent( _DualCommandBar * * __resultParent ) = 0;
};

class _CommandBarControls : public WOleDispatchHelper {

    public:

        _CommandBarControls();
        ~_CommandBarControls();

        /* Methods */
        WPIDispatch GetApplication( void );
        long GetCreator( void );
        _DualCommandBarControl * Add( WVariant __Type=WVariant(), WVariant __Id=WVariant(), WVariant __Parameter=WVariant(), WVariant __Before=WVariant(), WVariant __Temporary=WVariant() );
        int GetCount( void );
        _DualCommandBarControl * GetItem( WVariant __Index );
        WPIUnknown Get_NewEnum( void );
        _DualCommandBar * GetParent( void );

        _CommandBarControls & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _CommandBarControls & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualCommandBarControl : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetaccParent( WPIDispatch * __resultaccParent ) = 0;
        virtual WHRESULT GetaccChildCount( long * __resultaccChildCount ) = 0;
        virtual WHRESULT GetaccChild( WVARIANT __varChild, WPIDispatch * __resultaccChild ) = 0;
        virtual WHRESULT GetaccName( WVARIANT __varChild=WVariant(), WBStr * __resultaccName=NULL ) = 0;
        virtual WHRESULT GetaccValue( WVARIANT __varChild=WVariant(), WBStr * __resultaccValue=NULL ) = 0;
        virtual WHRESULT GetaccDescription( WVARIANT __varChild=WVariant(), WBStr * __resultaccDescription=NULL ) = 0;
        virtual WHRESULT GetaccRole( WVARIANT __varChild=WVariant(), WVARIANT * __resultaccRole=NULL ) = 0;
        virtual WHRESULT GetaccState( WVARIANT __varChild=WVariant(), WVARIANT * __resultaccState=NULL ) = 0;
        virtual WHRESULT GetaccHelp( WVARIANT __varChild=WVariant(), WBStr * __resultaccHelp=NULL ) = 0;
        virtual WHRESULT GetaccHelpTopic( WBStr * __pszHelpFile, WVARIANT __varChild=WVariant(), long * __resultaccHelpTopic=NULL ) = 0;
        virtual WHRESULT GetaccKeyboardShortcut( WVARIANT __varChild=WVariant(), WBStr * __resultaccKeyboardShortcut=NULL ) = 0;
        virtual WHRESULT GetaccFocus( WVARIANT * __resultaccFocus ) = 0;
        virtual WHRESULT GetaccSelection( WVARIANT * __resultaccSelection ) = 0;
        virtual WHRESULT GetaccDefaultAction( WVARIANT __varChild=WVariant(), WBStr * __resultaccDefaultAction=NULL ) = 0;
        virtual WHRESULT accSelect( long __flagsSelect, WVARIANT __varChild=WVariant() ) = 0;
        virtual WHRESULT accLocation( long * __pxLeft, long * __pyTop, long * __pcxWidth, long * __pcyHeight, WVARIANT __varChild=WVariant() ) = 0;
        virtual WHRESULT accNavigate( long __navDir, WVARIANT __varStart=WVariant(), WVARIANT * __resultaccNavigate=NULL ) = 0;
        virtual WHRESULT accHitTest( long __xLeft, long __yTop, WVARIANT * __resultaccHitTest ) = 0;
        virtual WHRESULT accDoDefaultAction( WVARIANT __varChild=WVariant() ) = 0;
        virtual WHRESULT SetaccName( WVARIANT __varChild, WBStr __accName ) = 0;
        virtual WHRESULT SetaccValue( WVARIANT __varChild, WBStr __accValue ) = 0;
        virtual WHRESULT GetApplication( WPIDispatch * __resultApplication ) = 0;
        virtual WHRESULT GetCreator( long * __resultCreator ) = 0;
        virtual WHRESULT GetBeginGroup( WVARIANT_BOOL * __resultBeginGroup ) = 0;
        virtual WHRESULT SetBeginGroup( WVARIANT_BOOL __BeginGroup ) = 0;
        virtual WHRESULT GetBuiltIn( WVARIANT_BOOL * __resultBuiltIn ) = 0;
        virtual WHRESULT GetCaption( WBStr * __resultCaption ) = 0;
        virtual WHRESULT SetCaption( WBStr __Caption ) = 0;
        virtual WHRESULT GetControl( WPIDispatch * __resultControl ) = 0;
        virtual WHRESULT Copy( WVARIANT __Bar=WVariant(), WVARIANT __Before=WVariant(), _DualCommandBarControl * * __resultCopy=NULL ) = 0;
        virtual WHRESULT Delete( WVARIANT __Temporary=WVariant() ) = 0;
        virtual WHRESULT GetDescriptionText( WBStr * __resultDescriptionText ) = 0;
        virtual WHRESULT SetDescriptionText( WBStr __DescriptionText ) = 0;
        virtual WHRESULT GetEnabled( WVARIANT_BOOL * __resultEnabled ) = 0;
        virtual WHRESULT SetEnabled( WVARIANT_BOOL __Enabled ) = 0;
        virtual WHRESULT Execute( void ) = 0;
        virtual WHRESULT GetHeight( int * __resultHeight ) = 0;
        virtual WHRESULT SetHeight( int __Height ) = 0;
        virtual WHRESULT GetHelpContextId( int * __resultHelpContextId ) = 0;
        virtual WHRESULT SetHelpContextId( int __HelpContextId ) = 0;
        virtual WHRESULT GetHelpFile( WBStr * __resultHelpFile ) = 0;
        virtual WHRESULT SetHelpFile( WBStr __HelpFile ) = 0;
        virtual WHRESULT GetId( int * __resultId ) = 0;
        virtual WHRESULT GetIndex( int * __resultIndex ) = 0;
        virtual WHRESULT GetInstanceId( long * __resultInstanceId ) = 0;
        virtual WHRESULT Move( WVARIANT __Bar=WVariant(), WVARIANT __Before=WVariant(), _DualCommandBarControl * * __resultMove=NULL ) = 0;
        virtual WHRESULT GetLeft( int * __resultLeft ) = 0;
        virtual WHRESULT GetOLEUsage( MsoControlOLEUsage * __resultOLEUsage ) = 0;
        virtual WHRESULT SetOLEUsage( MsoControlOLEUsage __OLEUsage ) = 0;
        virtual WHRESULT GetOnAction( WBStr * __resultOnAction ) = 0;
        virtual WHRESULT SetOnAction( WBStr __OnAction ) = 0;
        virtual WHRESULT GetParent( _DualCommandBar * * __resultParent ) = 0;
        virtual WHRESULT GetParameter( WBStr * __resultParameter ) = 0;
        virtual WHRESULT SetParameter( WBStr __Parameter ) = 0;
        virtual WHRESULT GetPriority( int * __resultPriority ) = 0;
        virtual WHRESULT SetPriority( int __Priority ) = 0;
        virtual WHRESULT Reset( void ) = 0;
        virtual WHRESULT SetFocus( void ) = 0;
        virtual WHRESULT GetTag( WBStr * __resultTag ) = 0;
        virtual WHRESULT SetTag( WBStr __Tag ) = 0;
        virtual WHRESULT GetTooltipText( WBStr * __resultTooltipText ) = 0;
        virtual WHRESULT SetTooltipText( WBStr __TooltipText ) = 0;
        virtual WHRESULT GetTop( int * __resultTop ) = 0;
        virtual WHRESULT GetType( MsoControlType * __resultType ) = 0;
        virtual WHRESULT GetVisible( WVARIANT_BOOL * __resultVisible ) = 0;
        virtual WHRESULT SetVisible( WVARIANT_BOOL __Visible ) = 0;
        virtual WHRESULT GetWidth( int * __resultWidth ) = 0;
        virtual WHRESULT SetWidth( int __Width ) = 0;
        virtual WHRESULT Reserved1( void ) = 0;
        virtual WHRESULT Reserved2( void ) = 0;
        virtual WHRESULT Reserved3( void ) = 0;
        virtual WHRESULT Reserved4( void ) = 0;
        virtual WHRESULT Reserved5( void ) = 0;
        virtual WHRESULT Reserved6( void ) = 0;
        virtual WHRESULT Reserved7( void ) = 0;
        virtual WHRESULT Reserved8( void ) = 0;
};

class _CommandBarControl : public WOleDispatchHelper {

    public:

        _CommandBarControl();
        ~_CommandBarControl();

        /* Methods */
        WPIDispatch GetApplication( void );
        long GetCreator( void );
        WVARIANT_BOOL GetBeginGroup( void );
        void SetBeginGroup( WVARIANT_BOOL __BeginGroup );
        WVARIANT_BOOL GetBuiltIn( void );
        WBString GetCaption( void );
        void SetCaption( WBString __Caption );
        _DualCommandBarControl * Copy( WVariant __Bar=WVariant(), WVariant __Before=WVariant() );
        void Delete( WVariant __Temporary=WVariant() );
        WBString GetDescriptionText( void );
        void SetDescriptionText( WBString __DescriptionText );
        WVARIANT_BOOL GetEnabled( void );
        void SetEnabled( WVARIANT_BOOL __Enabled );
        void Execute( void );
        int GetHeight( void );
        void SetHeight( int __Height );
        int GetHelpContextId( void );
        void SetHelpContextId( int __HelpContextId );
        WBString GetHelpFile( void );
        void SetHelpFile( WBString __HelpFile );
        int GetId( void );
        int GetIndex( void );
        _DualCommandBarControl * Move( WVariant __Bar=WVariant(), WVariant __Before=WVariant() );
        int GetLeft( void );
        MsoControlOLEUsage GetOLEUsage( void );
        void SetOLEUsage( MsoControlOLEUsage __OLEUsage );
        WBString GetOnAction( void );
        void SetOnAction( WBString __OnAction );
        _DualCommandBar * GetParent( void );
        WBString GetParameter( void );
        void SetParameter( WBString __Parameter );
        int GetPriority( void );
        void SetPriority( int __Priority );
        void Reset( void );
        void SetFocus( void );
        WBString GetTag( void );
        void SetTag( WBString __Tag );
        WBString GetTooltipText( void );
        void SetTooltipText( WBString __TooltipText );
        int GetTop( void );
        MsoControlType GetType( void );
        WVARIANT_BOOL GetVisible( void );
        void SetVisible( WVARIANT_BOOL __Visible );
        int GetWidth( void );
        void SetWidth( int __Width );

        _CommandBarControl & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _CommandBarControl & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualCommandBarButton : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetaccParent( WPIDispatch * __resultaccParent ) = 0;
        virtual WHRESULT GetaccChildCount( long * __resultaccChildCount ) = 0;
        virtual WHRESULT GetaccChild( WVARIANT __varChild, WPIDispatch * __resultaccChild ) = 0;
        virtual WHRESULT GetaccName( WVARIANT __varChild=WVariant(), WBStr * __resultaccName=NULL ) = 0;
        virtual WHRESULT GetaccValue( WVARIANT __varChild=WVariant(), WBStr * __resultaccValue=NULL ) = 0;
        virtual WHRESULT GetaccDescription( WVARIANT __varChild=WVariant(), WBStr * __resultaccDescription=NULL ) = 0;
        virtual WHRESULT GetaccRole( WVARIANT __varChild=WVariant(), WVARIANT * __resultaccRole=NULL ) = 0;
        virtual WHRESULT GetaccState( WVARIANT __varChild=WVariant(), WVARIANT * __resultaccState=NULL ) = 0;
        virtual WHRESULT GetaccHelp( WVARIANT __varChild=WVariant(), WBStr * __resultaccHelp=NULL ) = 0;
        virtual WHRESULT GetaccHelpTopic( WBStr * __pszHelpFile, WVARIANT __varChild=WVariant(), long * __resultaccHelpTopic=NULL ) = 0;
        virtual WHRESULT GetaccKeyboardShortcut( WVARIANT __varChild=WVariant(), WBStr * __resultaccKeyboardShortcut=NULL ) = 0;
        virtual WHRESULT GetaccFocus( WVARIANT * __resultaccFocus ) = 0;
        virtual WHRESULT GetaccSelection( WVARIANT * __resultaccSelection ) = 0;
        virtual WHRESULT GetaccDefaultAction( WVARIANT __varChild=WVariant(), WBStr * __resultaccDefaultAction=NULL ) = 0;
        virtual WHRESULT accSelect( long __flagsSelect, WVARIANT __varChild=WVariant() ) = 0;
        virtual WHRESULT accLocation( long * __pxLeft, long * __pyTop, long * __pcxWidth, long * __pcyHeight, WVARIANT __varChild=WVariant() ) = 0;
        virtual WHRESULT accNavigate( long __navDir, WVARIANT __varStart=WVariant(), WVARIANT * __resultaccNavigate=NULL ) = 0;
        virtual WHRESULT accHitTest( long __xLeft, long __yTop, WVARIANT * __resultaccHitTest ) = 0;
        virtual WHRESULT accDoDefaultAction( WVARIANT __varChild=WVariant() ) = 0;
        virtual WHRESULT SetaccName( WVARIANT __varChild, WBStr __accName ) = 0;
        virtual WHRESULT SetaccValue( WVARIANT __varChild, WBStr __accValue ) = 0;
        virtual WHRESULT GetApplication( WPIDispatch * __resultApplication ) = 0;
        virtual WHRESULT GetCreator( long * __resultCreator ) = 0;
        virtual WHRESULT GetBeginGroup( WVARIANT_BOOL * __resultBeginGroup ) = 0;
        virtual WHRESULT SetBeginGroup( WVARIANT_BOOL __BeginGroup ) = 0;
        virtual WHRESULT GetBuiltIn( WVARIANT_BOOL * __resultBuiltIn ) = 0;
        virtual WHRESULT GetCaption( WBStr * __resultCaption ) = 0;
        virtual WHRESULT SetCaption( WBStr __Caption ) = 0;
        virtual WHRESULT GetControl( WPIDispatch * __resultControl ) = 0;
        virtual WHRESULT Copy( WVARIANT __Bar=WVariant(), WVARIANT __Before=WVariant(), _DualCommandBarControl * * __resultCopy=NULL ) = 0;
        virtual WHRESULT Delete( WVARIANT __Temporary=WVariant() ) = 0;
        virtual WHRESULT GetDescriptionText( WBStr * __resultDescriptionText ) = 0;
        virtual WHRESULT SetDescriptionText( WBStr __DescriptionText ) = 0;
        virtual WHRESULT GetEnabled( WVARIANT_BOOL * __resultEnabled ) = 0;
        virtual WHRESULT SetEnabled( WVARIANT_BOOL __Enabled ) = 0;
        virtual WHRESULT Execute( void ) = 0;
        virtual WHRESULT GetHeight( int * __resultHeight ) = 0;
        virtual WHRESULT SetHeight( int __Height ) = 0;
        virtual WHRESULT GetHelpContextId( int * __resultHelpContextId ) = 0;
        virtual WHRESULT SetHelpContextId( int __HelpContextId ) = 0;
        virtual WHRESULT GetHelpFile( WBStr * __resultHelpFile ) = 0;
        virtual WHRESULT SetHelpFile( WBStr __HelpFile ) = 0;
        virtual WHRESULT GetId( int * __resultId ) = 0;
        virtual WHRESULT GetIndex( int * __resultIndex ) = 0;
        virtual WHRESULT GetInstanceId( long * __resultInstanceId ) = 0;
        virtual WHRESULT Move( WVARIANT __Bar=WVariant(), WVARIANT __Before=WVariant(), _DualCommandBarControl * * __resultMove=NULL ) = 0;
        virtual WHRESULT GetLeft( int * __resultLeft ) = 0;
        virtual WHRESULT GetOLEUsage( MsoControlOLEUsage * __resultOLEUsage ) = 0;
        virtual WHRESULT SetOLEUsage( MsoControlOLEUsage __OLEUsage ) = 0;
        virtual WHRESULT GetOnAction( WBStr * __resultOnAction ) = 0;
        virtual WHRESULT SetOnAction( WBStr __OnAction ) = 0;
        virtual WHRESULT GetParent( _DualCommandBar * * __resultParent ) = 0;
        virtual WHRESULT GetParameter( WBStr * __resultParameter ) = 0;
        virtual WHRESULT SetParameter( WBStr __Parameter ) = 0;
        virtual WHRESULT GetPriority( int * __resultPriority ) = 0;
        virtual WHRESULT SetPriority( int __Priority ) = 0;
        virtual WHRESULT Reset( void ) = 0;
        virtual WHRESULT SetFocus( void ) = 0;
        virtual WHRESULT GetTag( WBStr * __resultTag ) = 0;
        virtual WHRESULT SetTag( WBStr __Tag ) = 0;
        virtual WHRESULT GetTooltipText( WBStr * __resultTooltipText ) = 0;
        virtual WHRESULT SetTooltipText( WBStr __TooltipText ) = 0;
        virtual WHRESULT GetTop( int * __resultTop ) = 0;
        virtual WHRESULT GetType( MsoControlType * __resultType ) = 0;
        virtual WHRESULT GetVisible( WVARIANT_BOOL * __resultVisible ) = 0;
        virtual WHRESULT SetVisible( WVARIANT_BOOL __Visible ) = 0;
        virtual WHRESULT GetWidth( int * __resultWidth ) = 0;
        virtual WHRESULT SetWidth( int __Width ) = 0;
        virtual WHRESULT Reserved1( void ) = 0;
        virtual WHRESULT Reserved2( void ) = 0;
        virtual WHRESULT Reserved3( void ) = 0;
        virtual WHRESULT Reserved4( void ) = 0;
        virtual WHRESULT Reserved5( void ) = 0;
        virtual WHRESULT Reserved6( void ) = 0;
        virtual WHRESULT Reserved7( void ) = 0;
        virtual WHRESULT Reserved8( void ) = 0;
        virtual WHRESULT GetBuiltInFace( WVARIANT_BOOL * __resultBuiltInFace ) = 0;
        virtual WHRESULT SetBuiltInFace( WVARIANT_BOOL __BuiltInFace ) = 0;
        virtual WHRESULT CopyFace( void ) = 0;
        virtual WHRESULT GetFaceId( int * __resultFaceId ) = 0;
        virtual WHRESULT SetFaceId( int __FaceId ) = 0;
        virtual WHRESULT PasteFace( void ) = 0;
        virtual WHRESULT GetShortcutText( WBStr * __resultShortcutText ) = 0;
        virtual WHRESULT SetShortcutText( WBStr __ShortcutText ) = 0;
        virtual WHRESULT GetState( MsoButtonState * __resultState ) = 0;
        virtual WHRESULT SetState( MsoButtonState __State ) = 0;
        virtual WHRESULT GetStyle( MsoButtonStyle * __resultStyle ) = 0;
        virtual WHRESULT SetStyle( MsoButtonStyle __Style ) = 0;
};

class _CommandBarButton : public WOleDispatchHelper {

    public:

        _CommandBarButton();
        ~_CommandBarButton();

        /* Methods */
        WPIDispatch GetApplication( void );
        long GetCreator( void );
        WVARIANT_BOOL GetBeginGroup( void );
        void SetBeginGroup( WVARIANT_BOOL __BeginGroup );
        WVARIANT_BOOL GetBuiltIn( void );
        WBString GetCaption( void );
        void SetCaption( WBString __Caption );
        _DualCommandBarControl * Copy( WVariant __Bar=WVariant(), WVariant __Before=WVariant() );
        void Delete( WVariant __Temporary=WVariant() );
        WBString GetDescriptionText( void );
        void SetDescriptionText( WBString __DescriptionText );
        WVARIANT_BOOL GetEnabled( void );
        void SetEnabled( WVARIANT_BOOL __Enabled );
        void Execute( void );
        int GetHeight( void );
        void SetHeight( int __Height );
        int GetHelpContextId( void );
        void SetHelpContextId( int __HelpContextId );
        WBString GetHelpFile( void );
        void SetHelpFile( WBString __HelpFile );
        int GetId( void );
        int GetIndex( void );
        _DualCommandBarControl * Move( WVariant __Bar=WVariant(), WVariant __Before=WVariant() );
        int GetLeft( void );
        MsoControlOLEUsage GetOLEUsage( void );
        void SetOLEUsage( MsoControlOLEUsage __OLEUsage );
        WBString GetOnAction( void );
        void SetOnAction( WBString __OnAction );
        _DualCommandBar * GetParent( void );
        WBString GetParameter( void );
        void SetParameter( WBString __Parameter );
        int GetPriority( void );
        void SetPriority( int __Priority );
        void Reset( void );
        void SetFocus( void );
        WBString GetTag( void );
        void SetTag( WBString __Tag );
        WBString GetTooltipText( void );
        void SetTooltipText( WBString __TooltipText );
        int GetTop( void );
        MsoControlType GetType( void );
        WVARIANT_BOOL GetVisible( void );
        void SetVisible( WVARIANT_BOOL __Visible );
        int GetWidth( void );
        void SetWidth( int __Width );
        WVARIANT_BOOL GetBuiltInFace( void );
        void SetBuiltInFace( WVARIANT_BOOL __BuiltInFace );
        void CopyFace( void );
        int GetFaceId( void );
        void SetFaceId( int __FaceId );
        void PasteFace( void );
        WBString GetShortcutText( void );
        void SetShortcutText( WBString __ShortcutText );
        MsoButtonState GetState( void );
        void SetState( MsoButtonState __State );
        MsoButtonStyle GetStyle( void );
        void SetStyle( MsoButtonStyle __Style );

        _CommandBarButton & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _CommandBarButton & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualCommandBarPopup : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetaccParent( WPIDispatch * __resultaccParent ) = 0;
        virtual WHRESULT GetaccChildCount( long * __resultaccChildCount ) = 0;
        virtual WHRESULT GetaccChild( WVARIANT __varChild, WPIDispatch * __resultaccChild ) = 0;
        virtual WHRESULT GetaccName( WVARIANT __varChild=WVariant(), WBStr * __resultaccName=NULL ) = 0;
        virtual WHRESULT GetaccValue( WVARIANT __varChild=WVariant(), WBStr * __resultaccValue=NULL ) = 0;
        virtual WHRESULT GetaccDescription( WVARIANT __varChild=WVariant(), WBStr * __resultaccDescription=NULL ) = 0;
        virtual WHRESULT GetaccRole( WVARIANT __varChild=WVariant(), WVARIANT * __resultaccRole=NULL ) = 0;
        virtual WHRESULT GetaccState( WVARIANT __varChild=WVariant(), WVARIANT * __resultaccState=NULL ) = 0;
        virtual WHRESULT GetaccHelp( WVARIANT __varChild=WVariant(), WBStr * __resultaccHelp=NULL ) = 0;
        virtual WHRESULT GetaccHelpTopic( WBStr * __pszHelpFile, WVARIANT __varChild=WVariant(), long * __resultaccHelpTopic=NULL ) = 0;
        virtual WHRESULT GetaccKeyboardShortcut( WVARIANT __varChild=WVariant(), WBStr * __resultaccKeyboardShortcut=NULL ) = 0;
        virtual WHRESULT GetaccFocus( WVARIANT * __resultaccFocus ) = 0;
        virtual WHRESULT GetaccSelection( WVARIANT * __resultaccSelection ) = 0;
        virtual WHRESULT GetaccDefaultAction( WVARIANT __varChild=WVariant(), WBStr * __resultaccDefaultAction=NULL ) = 0;
        virtual WHRESULT accSelect( long __flagsSelect, WVARIANT __varChild=WVariant() ) = 0;
        virtual WHRESULT accLocation( long * __pxLeft, long * __pyTop, long * __pcxWidth, long * __pcyHeight, WVARIANT __varChild=WVariant() ) = 0;
        virtual WHRESULT accNavigate( long __navDir, WVARIANT __varStart=WVariant(), WVARIANT * __resultaccNavigate=NULL ) = 0;
        virtual WHRESULT accHitTest( long __xLeft, long __yTop, WVARIANT * __resultaccHitTest ) = 0;
        virtual WHRESULT accDoDefaultAction( WVARIANT __varChild=WVariant() ) = 0;
        virtual WHRESULT SetaccName( WVARIANT __varChild, WBStr __accName ) = 0;
        virtual WHRESULT SetaccValue( WVARIANT __varChild, WBStr __accValue ) = 0;
        virtual WHRESULT GetApplication( WPIDispatch * __resultApplication ) = 0;
        virtual WHRESULT GetCreator( long * __resultCreator ) = 0;
        virtual WHRESULT GetBeginGroup( WVARIANT_BOOL * __resultBeginGroup ) = 0;
        virtual WHRESULT SetBeginGroup( WVARIANT_BOOL __BeginGroup ) = 0;
        virtual WHRESULT GetBuiltIn( WVARIANT_BOOL * __resultBuiltIn ) = 0;
        virtual WHRESULT GetCaption( WBStr * __resultCaption ) = 0;
        virtual WHRESULT SetCaption( WBStr __Caption ) = 0;
        virtual WHRESULT GetControl( WPIDispatch * __resultControl ) = 0;
        virtual WHRESULT Copy( WVARIANT __Bar=WVariant(), WVARIANT __Before=WVariant(), _DualCommandBarControl * * __resultCopy=NULL ) = 0;
        virtual WHRESULT Delete( WVARIANT __Temporary=WVariant() ) = 0;
        virtual WHRESULT GetDescriptionText( WBStr * __resultDescriptionText ) = 0;
        virtual WHRESULT SetDescriptionText( WBStr __DescriptionText ) = 0;
        virtual WHRESULT GetEnabled( WVARIANT_BOOL * __resultEnabled ) = 0;
        virtual WHRESULT SetEnabled( WVARIANT_BOOL __Enabled ) = 0;
        virtual WHRESULT Execute( void ) = 0;
        virtual WHRESULT GetHeight( int * __resultHeight ) = 0;
        virtual WHRESULT SetHeight( int __Height ) = 0;
        virtual WHRESULT GetHelpContextId( int * __resultHelpContextId ) = 0;
        virtual WHRESULT SetHelpContextId( int __HelpContextId ) = 0;
        virtual WHRESULT GetHelpFile( WBStr * __resultHelpFile ) = 0;
        virtual WHRESULT SetHelpFile( WBStr __HelpFile ) = 0;
        virtual WHRESULT GetId( int * __resultId ) = 0;
        virtual WHRESULT GetIndex( int * __resultIndex ) = 0;
        virtual WHRESULT GetInstanceId( long * __resultInstanceId ) = 0;
        virtual WHRESULT Move( WVARIANT __Bar=WVariant(), WVARIANT __Before=WVariant(), _DualCommandBarControl * * __resultMove=NULL ) = 0;
        virtual WHRESULT GetLeft( int * __resultLeft ) = 0;
        virtual WHRESULT GetOLEUsage( MsoControlOLEUsage * __resultOLEUsage ) = 0;
        virtual WHRESULT SetOLEUsage( MsoControlOLEUsage __OLEUsage ) = 0;
        virtual WHRESULT GetOnAction( WBStr * __resultOnAction ) = 0;
        virtual WHRESULT SetOnAction( WBStr __OnAction ) = 0;
        virtual WHRESULT GetParent( _DualCommandBar * * __resultParent ) = 0;
        virtual WHRESULT GetParameter( WBStr * __resultParameter ) = 0;
        virtual WHRESULT SetParameter( WBStr __Parameter ) = 0;
        virtual WHRESULT GetPriority( int * __resultPriority ) = 0;
        virtual WHRESULT SetPriority( int __Priority ) = 0;
        virtual WHRESULT Reset( void ) = 0;
        virtual WHRESULT SetFocus( void ) = 0;
        virtual WHRESULT GetTag( WBStr * __resultTag ) = 0;
        virtual WHRESULT SetTag( WBStr __Tag ) = 0;
        virtual WHRESULT GetTooltipText( WBStr * __resultTooltipText ) = 0;
        virtual WHRESULT SetTooltipText( WBStr __TooltipText ) = 0;
        virtual WHRESULT GetTop( int * __resultTop ) = 0;
        virtual WHRESULT GetType( MsoControlType * __resultType ) = 0;
        virtual WHRESULT GetVisible( WVARIANT_BOOL * __resultVisible ) = 0;
        virtual WHRESULT SetVisible( WVARIANT_BOOL __Visible ) = 0;
        virtual WHRESULT GetWidth( int * __resultWidth ) = 0;
        virtual WHRESULT SetWidth( int __Width ) = 0;
        virtual WHRESULT Reserved1( void ) = 0;
        virtual WHRESULT Reserved2( void ) = 0;
        virtual WHRESULT Reserved3( void ) = 0;
        virtual WHRESULT Reserved4( void ) = 0;
        virtual WHRESULT Reserved5( void ) = 0;
        virtual WHRESULT Reserved6( void ) = 0;
        virtual WHRESULT Reserved7( void ) = 0;
        virtual WHRESULT Reserved8( void ) = 0;
        virtual WHRESULT GetCommandBar( _DualCommandBar * * __resultCommandBar ) = 0;
        virtual WHRESULT GetControls( _DualCommandBarControls * * __resultControls ) = 0;
        virtual WHRESULT GetOLEMenuGroup( MsoOLEMenuGroup * __resultOLEMenuGroup ) = 0;
        virtual WHRESULT SetOLEMenuGroup( MsoOLEMenuGroup __OLEMenuGroup ) = 0;
};

class _CommandBarPopup : public WOleDispatchHelper {

    public:

        _CommandBarPopup();
        ~_CommandBarPopup();

        /* Methods */
        WPIDispatch GetApplication( void );
        long GetCreator( void );
        WVARIANT_BOOL GetBeginGroup( void );
        void SetBeginGroup( WVARIANT_BOOL __BeginGroup );
        WVARIANT_BOOL GetBuiltIn( void );
        WBString GetCaption( void );
        void SetCaption( WBString __Caption );
        _DualCommandBarControl * Copy( WVariant __Bar=WVariant(), WVariant __Before=WVariant() );
        void Delete( WVariant __Temporary=WVariant() );
        WBString GetDescriptionText( void );
        void SetDescriptionText( WBString __DescriptionText );
        WVARIANT_BOOL GetEnabled( void );
        void SetEnabled( WVARIANT_BOOL __Enabled );
        void Execute( void );
        int GetHeight( void );
        void SetHeight( int __Height );
        int GetHelpContextId( void );
        void SetHelpContextId( int __HelpContextId );
        WBString GetHelpFile( void );
        void SetHelpFile( WBString __HelpFile );
        int GetId( void );
        int GetIndex( void );
        _DualCommandBarControl * Move( WVariant __Bar=WVariant(), WVariant __Before=WVariant() );
        int GetLeft( void );
        MsoControlOLEUsage GetOLEUsage( void );
        void SetOLEUsage( MsoControlOLEUsage __OLEUsage );
        WBString GetOnAction( void );
        void SetOnAction( WBString __OnAction );
        _DualCommandBar * GetParent( void );
        WBString GetParameter( void );
        void SetParameter( WBString __Parameter );
        int GetPriority( void );
        void SetPriority( int __Priority );
        void Reset( void );
        void SetFocus( void );
        WBString GetTag( void );
        void SetTag( WBString __Tag );
        WBString GetTooltipText( void );
        void SetTooltipText( WBString __TooltipText );
        int GetTop( void );
        MsoControlType GetType( void );
        WVARIANT_BOOL GetVisible( void );
        void SetVisible( WVARIANT_BOOL __Visible );
        int GetWidth( void );
        void SetWidth( int __Width );
        _DualCommandBar * GetCommandBar( void );
        _DualCommandBarControls * GetControls( void );
        MsoOLEMenuGroup GetOLEMenuGroup( void );
        void SetOLEMenuGroup( MsoOLEMenuGroup __OLEMenuGroup );

        _CommandBarPopup & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _CommandBarPopup & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualCommandBarComboBox : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetaccParent( WPIDispatch * __resultaccParent ) = 0;
        virtual WHRESULT GetaccChildCount( long * __resultaccChildCount ) = 0;
        virtual WHRESULT GetaccChild( WVARIANT __varChild, WPIDispatch * __resultaccChild ) = 0;
        virtual WHRESULT GetaccName( WVARIANT __varChild=WVariant(), WBStr * __resultaccName=NULL ) = 0;
        virtual WHRESULT GetaccValue( WVARIANT __varChild=WVariant(), WBStr * __resultaccValue=NULL ) = 0;
        virtual WHRESULT GetaccDescription( WVARIANT __varChild=WVariant(), WBStr * __resultaccDescription=NULL ) = 0;
        virtual WHRESULT GetaccRole( WVARIANT __varChild=WVariant(), WVARIANT * __resultaccRole=NULL ) = 0;
        virtual WHRESULT GetaccState( WVARIANT __varChild=WVariant(), WVARIANT * __resultaccState=NULL ) = 0;
        virtual WHRESULT GetaccHelp( WVARIANT __varChild=WVariant(), WBStr * __resultaccHelp=NULL ) = 0;
        virtual WHRESULT GetaccHelpTopic( WBStr * __pszHelpFile, WVARIANT __varChild=WVariant(), long * __resultaccHelpTopic=NULL ) = 0;
        virtual WHRESULT GetaccKeyboardShortcut( WVARIANT __varChild=WVariant(), WBStr * __resultaccKeyboardShortcut=NULL ) = 0;
        virtual WHRESULT GetaccFocus( WVARIANT * __resultaccFocus ) = 0;
        virtual WHRESULT GetaccSelection( WVARIANT * __resultaccSelection ) = 0;
        virtual WHRESULT GetaccDefaultAction( WVARIANT __varChild=WVariant(), WBStr * __resultaccDefaultAction=NULL ) = 0;
        virtual WHRESULT accSelect( long __flagsSelect, WVARIANT __varChild=WVariant() ) = 0;
        virtual WHRESULT accLocation( long * __pxLeft, long * __pyTop, long * __pcxWidth, long * __pcyHeight, WVARIANT __varChild=WVariant() ) = 0;
        virtual WHRESULT accNavigate( long __navDir, WVARIANT __varStart=WVariant(), WVARIANT * __resultaccNavigate=NULL ) = 0;
        virtual WHRESULT accHitTest( long __xLeft, long __yTop, WVARIANT * __resultaccHitTest ) = 0;
        virtual WHRESULT accDoDefaultAction( WVARIANT __varChild=WVariant() ) = 0;
        virtual WHRESULT SetaccName( WVARIANT __varChild, WBStr __accName ) = 0;
        virtual WHRESULT SetaccValue( WVARIANT __varChild, WBStr __accValue ) = 0;
        virtual WHRESULT GetApplication( WPIDispatch * __resultApplication ) = 0;
        virtual WHRESULT GetCreator( long * __resultCreator ) = 0;
        virtual WHRESULT GetBeginGroup( WVARIANT_BOOL * __resultBeginGroup ) = 0;
        virtual WHRESULT SetBeginGroup( WVARIANT_BOOL __BeginGroup ) = 0;
        virtual WHRESULT GetBuiltIn( WVARIANT_BOOL * __resultBuiltIn ) = 0;
        virtual WHRESULT GetCaption( WBStr * __resultCaption ) = 0;
        virtual WHRESULT SetCaption( WBStr __Caption ) = 0;
        virtual WHRESULT GetControl( WPIDispatch * __resultControl ) = 0;
        virtual WHRESULT Copy( WVARIANT __Bar=WVariant(), WVARIANT __Before=WVariant(), _DualCommandBarControl * * __resultCopy=NULL ) = 0;
        virtual WHRESULT Delete( WVARIANT __Temporary=WVariant() ) = 0;
        virtual WHRESULT GetDescriptionText( WBStr * __resultDescriptionText ) = 0;
        virtual WHRESULT SetDescriptionText( WBStr __DescriptionText ) = 0;
        virtual WHRESULT GetEnabled( WVARIANT_BOOL * __resultEnabled ) = 0;
        virtual WHRESULT SetEnabled( WVARIANT_BOOL __Enabled ) = 0;
        virtual WHRESULT Execute( void ) = 0;
        virtual WHRESULT GetHeight( int * __resultHeight ) = 0;
        virtual WHRESULT SetHeight( int __Height ) = 0;
        virtual WHRESULT GetHelpContextId( int * __resultHelpContextId ) = 0;
        virtual WHRESULT SetHelpContextId( int __HelpContextId ) = 0;
        virtual WHRESULT GetHelpFile( WBStr * __resultHelpFile ) = 0;
        virtual WHRESULT SetHelpFile( WBStr __HelpFile ) = 0;
        virtual WHRESULT GetId( int * __resultId ) = 0;
        virtual WHRESULT GetIndex( int * __resultIndex ) = 0;
        virtual WHRESULT GetInstanceId( long * __resultInstanceId ) = 0;
        virtual WHRESULT Move( WVARIANT __Bar=WVariant(), WVARIANT __Before=WVariant(), _DualCommandBarControl * * __resultMove=NULL ) = 0;
        virtual WHRESULT GetLeft( int * __resultLeft ) = 0;
        virtual WHRESULT GetOLEUsage( MsoControlOLEUsage * __resultOLEUsage ) = 0;
        virtual WHRESULT SetOLEUsage( MsoControlOLEUsage __OLEUsage ) = 0;
        virtual WHRESULT GetOnAction( WBStr * __resultOnAction ) = 0;
        virtual WHRESULT SetOnAction( WBStr __OnAction ) = 0;
        virtual WHRESULT GetParent( _DualCommandBar * * __resultParent ) = 0;
        virtual WHRESULT GetParameter( WBStr * __resultParameter ) = 0;
        virtual WHRESULT SetParameter( WBStr __Parameter ) = 0;
        virtual WHRESULT GetPriority( int * __resultPriority ) = 0;
        virtual WHRESULT SetPriority( int __Priority ) = 0;
        virtual WHRESULT Reset( void ) = 0;
        virtual WHRESULT SetFocus( void ) = 0;
        virtual WHRESULT GetTag( WBStr * __resultTag ) = 0;
        virtual WHRESULT SetTag( WBStr __Tag ) = 0;
        virtual WHRESULT GetTooltipText( WBStr * __resultTooltipText ) = 0;
        virtual WHRESULT SetTooltipText( WBStr __TooltipText ) = 0;
        virtual WHRESULT GetTop( int * __resultTop ) = 0;
        virtual WHRESULT GetType( MsoControlType * __resultType ) = 0;
        virtual WHRESULT GetVisible( WVARIANT_BOOL * __resultVisible ) = 0;
        virtual WHRESULT SetVisible( WVARIANT_BOOL __Visible ) = 0;
        virtual WHRESULT GetWidth( int * __resultWidth ) = 0;
        virtual WHRESULT SetWidth( int __Width ) = 0;
        virtual WHRESULT Reserved1( void ) = 0;
        virtual WHRESULT Reserved2( void ) = 0;
        virtual WHRESULT Reserved3( void ) = 0;
        virtual WHRESULT Reserved4( void ) = 0;
        virtual WHRESULT Reserved5( void ) = 0;
        virtual WHRESULT Reserved6( void ) = 0;
        virtual WHRESULT Reserved7( void ) = 0;
        virtual WHRESULT Reserved8( void ) = 0;
        virtual WHRESULT AddItem( WBStr __Text, WVARIANT __Index=WVariant() ) = 0;
        virtual WHRESULT Clear( void ) = 0;
        virtual WHRESULT GetDropDownLines( int * __resultDropDownLines ) = 0;
        virtual WHRESULT SetDropDownLines( int __DropDownLines ) = 0;
        virtual WHRESULT GetDropDownWidth( int * __resultDropDownWidth ) = 0;
        virtual WHRESULT SetDropDownWidth( int __DropDownWidth ) = 0;
        virtual WHRESULT GetList( int __Index, WBStr * __resultList ) = 0;
        virtual WHRESULT SetList( int __Index, WBStr __List ) = 0;
        virtual WHRESULT GetListCount( int * __resultListCount ) = 0;
        virtual WHRESULT GetListHeaderCount( int * __resultListHeaderCount ) = 0;
        virtual WHRESULT SetListHeaderCount( int __ListHeaderCount ) = 0;
        virtual WHRESULT GetListIndex( int * __resultListIndex ) = 0;
        virtual WHRESULT SetListIndex( int __ListIndex ) = 0;
        virtual WHRESULT RemoveItem( int __Index ) = 0;
        virtual WHRESULT GetStyle( MsoComboStyle * __resultStyle ) = 0;
        virtual WHRESULT SetStyle( MsoComboStyle __Style ) = 0;
        virtual WHRESULT GetText( WBStr * __resultText ) = 0;
        virtual WHRESULT SetText( WBStr __Text ) = 0;
};

class _CommandBarComboBox : public WOleDispatchHelper {

    public:

        _CommandBarComboBox();
        ~_CommandBarComboBox();

        /* Methods */
        WPIDispatch GetApplication( void );
        long GetCreator( void );
        WVARIANT_BOOL GetBeginGroup( void );
        void SetBeginGroup( WVARIANT_BOOL __BeginGroup );
        WVARIANT_BOOL GetBuiltIn( void );
        WBString GetCaption( void );
        void SetCaption( WBString __Caption );
        _DualCommandBarControl * Copy( WVariant __Bar=WVariant(), WVariant __Before=WVariant() );
        void Delete( WVariant __Temporary=WVariant() );
        WBString GetDescriptionText( void );
        void SetDescriptionText( WBString __DescriptionText );
        WVARIANT_BOOL GetEnabled( void );
        void SetEnabled( WVARIANT_BOOL __Enabled );
        void Execute( void );
        int GetHeight( void );
        void SetHeight( int __Height );
        int GetHelpContextId( void );
        void SetHelpContextId( int __HelpContextId );
        WBString GetHelpFile( void );
        void SetHelpFile( WBString __HelpFile );
        int GetId( void );
        int GetIndex( void );
        _DualCommandBarControl * Move( WVariant __Bar=WVariant(), WVariant __Before=WVariant() );
        int GetLeft( void );
        MsoControlOLEUsage GetOLEUsage( void );
        void SetOLEUsage( MsoControlOLEUsage __OLEUsage );
        WBString GetOnAction( void );
        void SetOnAction( WBString __OnAction );
        _DualCommandBar * GetParent( void );
        WBString GetParameter( void );
        void SetParameter( WBString __Parameter );
        int GetPriority( void );
        void SetPriority( int __Priority );
        void Reset( void );
        void SetFocus( void );
        WBString GetTag( void );
        void SetTag( WBString __Tag );
        WBString GetTooltipText( void );
        void SetTooltipText( WBString __TooltipText );
        int GetTop( void );
        MsoControlType GetType( void );
        WVARIANT_BOOL GetVisible( void );
        void SetVisible( WVARIANT_BOOL __Visible );
        int GetWidth( void );
        void SetWidth( int __Width );
        void AddItem( WBString __Text, WVariant __Index=WVariant() );
        void Clear( void );
        int GetDropDownLines( void );
        void SetDropDownLines( int __DropDownLines );
        int GetDropDownWidth( void );
        void SetDropDownWidth( int __DropDownWidth );
        WBString GetList( int __Index );
        void SetList( int __Index, WBString __List );
        int GetListCount( void );
        int GetListHeaderCount( void );
        void SetListHeaderCount( int __ListHeaderCount );
        int GetListIndex( void );
        void SetListIndex( int __ListIndex );
        void RemoveItem( int __Index );
        MsoComboStyle GetStyle( void );
        void SetStyle( MsoComboStyle __Style );
        WBString GetText( void );
        void SetText( WBString __Text );

        _CommandBarComboBox & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _CommandBarComboBox & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualAssistant : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetApplication( WPIDispatch * __resultApplication ) = 0;
        virtual WHRESULT GetCreator( long * __resultCreator ) = 0;
        virtual WHRESULT GetParent( WPIDispatch * __resultParent ) = 0;
        virtual WHRESULT Move( int __xLeft, int __yTop ) = 0;
        virtual WHRESULT SetTop( int __Top ) = 0;
        virtual WHRESULT GetTop( int * __resultTop ) = 0;
        virtual WHRESULT SetLeft( int __Left ) = 0;
        virtual WHRESULT GetLeft( int * __resultLeft ) = 0;
        virtual WHRESULT Help( void ) = 0;
        virtual WHRESULT StartWizard( WVARIANT_BOOL __On, WBStr __Callback, long __PrivateX, WVARIANT __Animation=WVariant(), WVARIANT __CustomTeaser=WVariant(), WVARIANT __Top=WVariant(), WVARIANT __Left=WVariant(), WVARIANT __Bottom=WVariant()
            , WVARIANT __Right=WVariant(), long * __resultStartWizard=NULL ) = 0;
        virtual WHRESULT EndWizard( long __WizardID, WVARIANT_BOOL __varfSuccess, WVARIANT __Animation=WVariant() ) = 0;
        virtual WHRESULT ActivateWizard( long __WizardID, MsoWizardActType __act, WVARIANT __Animation=WVariant() ) = 0;
        virtual WHRESULT ResetTips( void ) = 0;
        virtual WHRESULT GetNewBalloon( WPIDispatch * __resultNewBalloon ) = 0;
        virtual WHRESULT GetBalloonError( MsoBalloonErrorType * __resultBalloonError ) = 0;
        virtual WHRESULT GetVisible( WVARIANT_BOOL * __resultVisible ) = 0;
        virtual WHRESULT SetVisible( WVARIANT_BOOL __Visible ) = 0;
        virtual WHRESULT GetAnimation( MsoAnimationType * __resultAnimation ) = 0;
        virtual WHRESULT SetAnimation( MsoAnimationType __Animation ) = 0;
        virtual WHRESULT GetReduced( WVARIANT_BOOL * __resultReduced ) = 0;
        virtual WHRESULT SetReduced( WVARIANT_BOOL __Reduced ) = 0;
        virtual WHRESULT SetAssistWithHelp( WVARIANT_BOOL __AssistWithHelp ) = 0;
        virtual WHRESULT GetAssistWithHelp( WVARIANT_BOOL * __resultAssistWithHelp ) = 0;
        virtual WHRESULT SetAssistWithWizards( WVARIANT_BOOL __AssistWithWizards ) = 0;
        virtual WHRESULT GetAssistWithWizards( WVARIANT_BOOL * __resultAssistWithWizards ) = 0;
        virtual WHRESULT SetAssistWithAlerts( WVARIANT_BOOL __AssistWithAlerts ) = 0;
        virtual WHRESULT GetAssistWithAlerts( WVARIANT_BOOL * __resultAssistWithAlerts ) = 0;
        virtual WHRESULT SetMoveWhenInTheWay( WVARIANT_BOOL __MoveWhenInTheWay ) = 0;
        virtual WHRESULT GetMoveWhenInTheWay( WVARIANT_BOOL * __resultMoveWhenInTheWay ) = 0;
        virtual WHRESULT SetSounds( WVARIANT_BOOL __Sounds ) = 0;
        virtual WHRESULT GetSounds( WVARIANT_BOOL * __resultSounds ) = 0;
        virtual WHRESULT SetFeatureTips( WVARIANT_BOOL __FeatureTips ) = 0;
        virtual WHRESULT GetFeatureTips( WVARIANT_BOOL * __resultFeatureTips ) = 0;
        virtual WHRESULT SetMouseTips( WVARIANT_BOOL __MouseTips ) = 0;
        virtual WHRESULT GetMouseTips( WVARIANT_BOOL * __resultMouseTips ) = 0;
        virtual WHRESULT SetKeyboardShortcutTips( WVARIANT_BOOL __KeyboardShortcutTips ) = 0;
        virtual WHRESULT GetKeyboardShortcutTips( WVARIANT_BOOL * __resultKeyboardShortcutTips ) = 0;
        virtual WHRESULT SetHighPriorityTips( WVARIANT_BOOL __HighPriorityTips ) = 0;
        virtual WHRESULT GetHighPriorityTips( WVARIANT_BOOL * __resultHighPriorityTips ) = 0;
        virtual WHRESULT SetTipOfDay( WVARIANT_BOOL __TipOfDay ) = 0;
        virtual WHRESULT GetTipOfDay( WVARIANT_BOOL * __resultTipOfDay ) = 0;
        virtual WHRESULT SetGuessHelp( WVARIANT_BOOL __GuessHelp ) = 0;
        virtual WHRESULT GetGuessHelp( WVARIANT_BOOL * __resultGuessHelp ) = 0;
        virtual WHRESULT SetSearchWhenProgramming( WVARIANT_BOOL __SearchWhenProgramming ) = 0;
        virtual WHRESULT GetSearchWhenProgramming( WVARIANT_BOOL * __resultSearchWhenProgramming ) = 0;
        virtual WHRESULT GetItem( WBStr * __resultItem ) = 0;
        virtual WHRESULT GetFileName( WBStr * __resultFileName ) = 0;
        virtual WHRESULT SetFileName( WBStr __FileName ) = 0;
        virtual WHRESULT GetName( WBStr * __resultName ) = 0;
};

class _Assistant : public WOleDispatchHelper {

    public:

        _Assistant();
        ~_Assistant();

        /* Methods */
        WPIDispatch GetApplication( void );
        long GetCreator( void );
        WPIDispatch GetParent( void );
        void Move( int __xLeft, int __yTop );
        void SetTop( int __Top );
        int GetTop( void );
        void SetLeft( int __Left );
        int GetLeft( void );
        void Help( void );
        long StartWizard( WVARIANT_BOOL __On, WBString __Callback, long __PrivateX, WVariant __Animation=WVariant(), WVariant __CustomTeaser=WVariant(), WVariant __Top=WVariant(), WVariant __Left=WVariant(), WVariant __Bottom=WVariant()
            , WVariant __Right=WVariant() );
        void EndWizard( long __WizardID, WVARIANT_BOOL __varfSuccess, WVariant __Animation=WVariant() );
        void ActivateWizard( long __WizardID, MsoWizardActType __act, WVariant __Animation=WVariant() );
        void ResetTips( void );
        WPIDispatch GetNewBalloon( void );
        MsoBalloonErrorType GetBalloonError( void );
        WVARIANT_BOOL GetVisible( void );
        void SetVisible( WVARIANT_BOOL __Visible );
        MsoAnimationType GetAnimation( void );
        void SetAnimation( MsoAnimationType __Animation );
        WVARIANT_BOOL GetReduced( void );
        void SetReduced( WVARIANT_BOOL __Reduced );
        void SetAssistWithHelp( WVARIANT_BOOL __AssistWithHelp );
        WVARIANT_BOOL GetAssistWithHelp( void );
        void SetAssistWithWizards( WVARIANT_BOOL __AssistWithWizards );
        WVARIANT_BOOL GetAssistWithWizards( void );
        void SetAssistWithAlerts( WVARIANT_BOOL __AssistWithAlerts );
        WVARIANT_BOOL GetAssistWithAlerts( void );
        void SetMoveWhenInTheWay( WVARIANT_BOOL __MoveWhenInTheWay );
        WVARIANT_BOOL GetMoveWhenInTheWay( void );
        void SetSounds( WVARIANT_BOOL __Sounds );
        WVARIANT_BOOL GetSounds( void );
        void SetFeatureTips( WVARIANT_BOOL __FeatureTips );
        WVARIANT_BOOL GetFeatureTips( void );
        void SetMouseTips( WVARIANT_BOOL __MouseTips );
        WVARIANT_BOOL GetMouseTips( void );
        void SetKeyboardShortcutTips( WVARIANT_BOOL __KeyboardShortcutTips );
        WVARIANT_BOOL GetKeyboardShortcutTips( void );
        void SetHighPriorityTips( WVARIANT_BOOL __HighPriorityTips );
        WVARIANT_BOOL GetHighPriorityTips( void );
        void SetTipOfDay( WVARIANT_BOOL __TipOfDay );
        WVARIANT_BOOL GetTipOfDay( void );
        void SetGuessHelp( WVARIANT_BOOL __GuessHelp );
        WVARIANT_BOOL GetGuessHelp( void );
        void SetSearchWhenProgramming( WVARIANT_BOOL __SearchWhenProgramming );
        WVARIANT_BOOL GetSearchWhenProgramming( void );
        WBString GetItem( void );
        WBString GetFileName( void );
        void SetFileName( WBString __FileName );
        WBString GetName( void );

        _Assistant & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _Assistant & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualBalloon : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetApplication( WPIDispatch * __resultApplication ) = 0;
        virtual WHRESULT GetCreator( long * __resultCreator ) = 0;
        virtual WHRESULT GetParent( WPIDispatch * __resultParent ) = 0;
        virtual WHRESULT GetCheckboxes( WPIDispatch * __resultCheckboxes ) = 0;
        virtual WHRESULT GetLabels( WPIDispatch * __resultLabels ) = 0;
        virtual WHRESULT SetBalloonType( MsoBalloonType __BalloonType ) = 0;
        virtual WHRESULT GetBalloonType( MsoBalloonType * __resultBalloonType ) = 0;
        virtual WHRESULT SetIcon( MsoIconType __Icon ) = 0;
        virtual WHRESULT GetIcon( MsoIconType * __resultIcon ) = 0;
        virtual WHRESULT SetHeading( WBStr __Heading ) = 0;
        virtual WHRESULT GetHeading( WBStr * __resultHeading ) = 0;
        virtual WHRESULT SetText( WBStr __Text ) = 0;
        virtual WHRESULT GetText( WBStr * __resultText ) = 0;
        virtual WHRESULT SetMode( MsoModeType __Mode ) = 0;
        virtual WHRESULT GetMode( MsoModeType * __resultMode ) = 0;
        virtual WHRESULT SetAnimation( MsoAnimationType __Animation ) = 0;
        virtual WHRESULT GetAnimation( MsoAnimationType * __resultAnimation ) = 0;
        virtual WHRESULT SetButton( MsoButtonSetType __Button ) = 0;
        virtual WHRESULT GetButton( MsoButtonSetType * __resultButton ) = 0;
        virtual WHRESULT SetCallback( WBStr __Callback ) = 0;
        virtual WHRESULT GetCallback( WBStr * __resultCallback ) = 0;
        virtual WHRESULT SetPrivate( long __Private ) = 0;
        virtual WHRESULT GetPrivate( long * __resultPrivate ) = 0;
        virtual WHRESULT SetAvoidRectangle( int __Left, int __Top, int __Right, int __Bottom ) = 0;
        virtual WHRESULT GetName( WBStr * __resultName ) = 0;
        virtual WHRESULT Show( MsoBalloonButtonType * __resultShow ) = 0;
        virtual WHRESULT Close( void ) = 0;
};

class _Balloon : public WOleDispatchHelper {

    public:

        _Balloon();
        ~_Balloon();

        /* Methods */
        WPIDispatch GetApplication( void );
        long GetCreator( void );
        WPIDispatch GetParent( void );
        WPIDispatch GetCheckboxes( void );
        WPIDispatch GetLabels( void );
        void SetBalloonType( MsoBalloonType __BalloonType );
        MsoBalloonType GetBalloonType( void );
        void SetIcon( MsoIconType __Icon );
        MsoIconType GetIcon( void );
        void SetHeading( WBString __Heading );
        WBString GetHeading( void );
        void SetText( WBString __Text );
        WBString GetText( void );
        void SetMode( MsoModeType __Mode );
        MsoModeType GetMode( void );
        void SetAnimation( MsoAnimationType __Animation );
        MsoAnimationType GetAnimation( void );
        void SetButton( MsoButtonSetType __Button );
        MsoButtonSetType GetButton( void );
        void SetCallback( WBString __Callback );
        WBString GetCallback( void );
        void SetPrivate( long __Private );
        long GetPrivate( void );
        void SetAvoidRectangle( int __Left, int __Top, int __Right, int __Bottom );
        WBString GetName( void );
        MsoBalloonButtonType Show( void );
        void Close( void );

        _Balloon & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _Balloon & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualBalloonCheckboxes : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetApplication( WPIDispatch * __resultApplication ) = 0;
        virtual WHRESULT GetCreator( long * __resultCreator ) = 0;
        virtual WHRESULT GetName( WBStr * __resultName ) = 0;
        virtual WHRESULT GetParent( WPIDispatch * __resultParent ) = 0;
        virtual WHRESULT GetItem( int __Index, WPIDispatch * __resultItem ) = 0;
        virtual WHRESULT GetCount( int * __resultCount ) = 0;
        virtual WHRESULT SetCount( int __Count ) = 0;
        virtual WHRESULT Get_NewEnum( WPIUnknown * __result_NewEnum ) = 0;
};

class _BalloonCheckboxes : public WOleDispatchHelper {

    public:

        _BalloonCheckboxes();
        ~_BalloonCheckboxes();

        /* Methods */
        WPIDispatch GetApplication( void );
        long GetCreator( void );
        WBString GetName( void );
        WPIDispatch GetParent( void );
        WPIDispatch GetItem( int __Index );
        int GetCount( void );
        void SetCount( int __Count );
        WPIUnknown Get_NewEnum( void );

        _BalloonCheckboxes & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _BalloonCheckboxes & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualBalloonCheckbox : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetApplication( WPIDispatch * __resultApplication ) = 0;
        virtual WHRESULT GetCreator( long * __resultCreator ) = 0;
        virtual WHRESULT GetItem( WBStr * __resultItem ) = 0;
        virtual WHRESULT GetName( WBStr * __resultName ) = 0;
        virtual WHRESULT GetParent( WPIDispatch * __resultParent ) = 0;
        virtual WHRESULT SetChecked( WVARIANT_BOOL __Checked ) = 0;
        virtual WHRESULT GetChecked( WVARIANT_BOOL * __resultChecked ) = 0;
        virtual WHRESULT SetText( WBStr __Text ) = 0;
        virtual WHRESULT GetText( WBStr * __resultText ) = 0;
};

class _BalloonCheckbox : public WOleDispatchHelper {

    public:

        _BalloonCheckbox();
        ~_BalloonCheckbox();

        /* Methods */
        WPIDispatch GetApplication( void );
        long GetCreator( void );
        WBString GetItem( void );
        WBString GetName( void );
        WPIDispatch GetParent( void );
        void SetChecked( WVARIANT_BOOL __Checked );
        WVARIANT_BOOL GetChecked( void );
        void SetText( WBString __Text );
        WBString GetText( void );

        _BalloonCheckbox & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _BalloonCheckbox & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualBalloonLabels : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetApplication( WPIDispatch * __resultApplication ) = 0;
        virtual WHRESULT GetCreator( long * __resultCreator ) = 0;
        virtual WHRESULT GetName( WBStr * __resultName ) = 0;
        virtual WHRESULT GetParent( WPIDispatch * __resultParent ) = 0;
        virtual WHRESULT GetItem( int __Index, WPIDispatch * __resultItem ) = 0;
        virtual WHRESULT GetCount( int * __resultCount ) = 0;
        virtual WHRESULT SetCount( int __Count ) = 0;
        virtual WHRESULT Get_NewEnum( WPIUnknown * __result_NewEnum ) = 0;
};

class _BalloonLabels : public WOleDispatchHelper {

    public:

        _BalloonLabels();
        ~_BalloonLabels();

        /* Methods */
        WPIDispatch GetApplication( void );
        long GetCreator( void );
        WBString GetName( void );
        WPIDispatch GetParent( void );
        WPIDispatch GetItem( int __Index );
        int GetCount( void );
        void SetCount( int __Count );
        WPIUnknown Get_NewEnum( void );

        _BalloonLabels & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _BalloonLabels & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualBalloonLabel : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetApplication( WPIDispatch * __resultApplication ) = 0;
        virtual WHRESULT GetCreator( long * __resultCreator ) = 0;
        virtual WHRESULT GetItem( WBStr * __resultItem ) = 0;
        virtual WHRESULT GetName( WBStr * __resultName ) = 0;
        virtual WHRESULT GetParent( WPIDispatch * __resultParent ) = 0;
        virtual WHRESULT SetText( WBStr __Text ) = 0;
        virtual WHRESULT GetText( WBStr * __resultText ) = 0;
};

class _BalloonLabel : public WOleDispatchHelper {

    public:

        _BalloonLabel();
        ~_BalloonLabel();

        /* Methods */
        WPIDispatch GetApplication( void );
        long GetCreator( void );
        WBString GetItem( void );
        WBString GetName( void );
        WPIDispatch GetParent( void );
        void SetText( WBString __Text );
        WBString GetText( void );

        _BalloonLabel & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _BalloonLabel & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall DocumentProperty : public IDispatch {

    public:

        /* Methods */
        virtual WPIDispatch GetParent( void ) = 0;
        virtual WHRESULT Delete( void ) = 0;
        virtual WHRESULT GetName( long __lcid, WBStr * __pbstrRetVal ) = 0;
        virtual WHRESULT SetName( long __lcid, WBStr __Name ) = 0;
        virtual WHRESULT GetValue( long __lcid, WVARIANT * __pvargRetVal ) = 0;
        virtual WHRESULT SetValue( long __lcid, WVARIANT __Value ) = 0;
        virtual WHRESULT GetType( long __lcid, MsoDocProperties * __ptypeRetVal ) = 0;
        virtual WHRESULT SetType( long __lcid, MsoDocProperties __Type ) = 0;
        virtual WHRESULT GetLinkToContent( WVARIANT_BOOL * __pfLinkRetVal ) = 0;
        virtual WHRESULT SetLinkToContent( WVARIANT_BOOL __LinkToContent ) = 0;
        virtual WHRESULT GetLinkSource( WBStr * __pbstrSourceRetVal ) = 0;
        virtual WHRESULT SetLinkSource( WBStr __LinkSource ) = 0;
        virtual WHRESULT GetApplication( WPIDispatch * __ppidisp ) = 0;
        virtual WHRESULT GetCreator( long * __plCreator ) = 0;
};

class __stdcall DocumentProperties : public IDispatch {

    public:

        /* Methods */
        virtual WPIDispatch GetParent( void ) = 0;
        virtual WHRESULT GetItem( WVARIANT __Index, long __lcid, DocumentProperty * * __ppIDocProp ) = 0;
        virtual WHRESULT GetCount( long * __pc ) = 0;
        virtual WHRESULT Add( WBStr __Name, WVARIANT_BOOL __LinkToContent, WVARIANT __Type, WVARIANT __Value, WVARIANT __LinkSource, long __lcid, DocumentProperty * * __ppIDocProp=NULL ) = 0;
        virtual WHRESULT Get_NewEnum( WPIUnknown * __ppunkEnum ) = 0;
        virtual WHRESULT GetApplication( WPIDispatch * __ppidisp ) = 0;
        virtual WHRESULT GetCreator( long * __plCreator ) = 0;
};

class __stdcall _DualIFoundFiles : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetItem( int __Index, WBStr * __resultItem ) = 0;
        virtual WHRESULT GetCount( int * __resultCount ) = 0;
        virtual WHRESULT Get_NewEnum( WPIUnknown * __result_NewEnum ) = 0;
};

class _IFoundFiles : public WOleDispatchHelper {

    public:

        _IFoundFiles();
        ~_IFoundFiles();

        /* Methods */
        WBString GetItem( int __Index );
        int GetCount( void );
        WPIUnknown Get_NewEnum( void );

        _IFoundFiles & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _IFoundFiles & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualIFind : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetSearchPath( WBStr * __resultSearchPath ) = 0;
        virtual WHRESULT GetName( WBStr * __resultName ) = 0;
        virtual WHRESULT GetSubDir( WVARIANT_BOOL * __resultSubDir ) = 0;
        virtual WHRESULT GetTitle( WBStr * __resultTitle ) = 0;
        virtual WHRESULT GetAuthor( WBStr * __resultAuthor ) = 0;
        virtual WHRESULT GetKeywords( WBStr * __resultKeywords ) = 0;
        virtual WHRESULT GetSubject( WBStr * __resultSubject ) = 0;
        virtual WHRESULT GetOptions( MsoFileFindOptions * __resultOptions ) = 0;
        virtual WHRESULT GetMatchCase( WVARIANT_BOOL * __resultMatchCase ) = 0;
        virtual WHRESULT GetText( WBStr * __resultText ) = 0;
        virtual WHRESULT GetPatternMatch( WVARIANT_BOOL * __resultPatternMatch ) = 0;
        virtual WHRESULT GetDateSavedFrom( WVARIANT * __resultDateSavedFrom ) = 0;
        virtual WHRESULT GetDateSavedTo( WVARIANT * __resultDateSavedTo ) = 0;
        virtual WHRESULT GetSavedBy( WBStr * __resultSavedBy ) = 0;
        virtual WHRESULT GetDateCreatedFrom( WVARIANT * __resultDateCreatedFrom ) = 0;
        virtual WHRESULT GetDateCreatedTo( WVARIANT * __resultDateCreatedTo ) = 0;
        virtual WHRESULT GetView( MsoFileFindView * __resultView ) = 0;
        virtual WHRESULT GetSortBy( MsoFileFindSortBy * __resultSortBy ) = 0;
        virtual WHRESULT GetListBy( MsoFileFindListBy * __resultListBy ) = 0;
        virtual WHRESULT GetSelectedFile( int * __resultSelectedFile ) = 0;
        virtual WHRESULT GetResults( _DualIFoundFiles * * __resultResults ) = 0;
        virtual WHRESULT Show( int * __resultShow ) = 0;
        virtual WHRESULT SetSearchPath( WBStr __SearchPath ) = 0;
        virtual WHRESULT SetName( WBStr __Name ) = 0;
        virtual WHRESULT SetSubDir( WVARIANT_BOOL __SubDir ) = 0;
        virtual WHRESULT SetTitle( WBStr __Title ) = 0;
        virtual WHRESULT SetAuthor( WBStr __Author ) = 0;
        virtual WHRESULT SetKeywords( WBStr __Keywords ) = 0;
        virtual WHRESULT SetSubject( WBStr __Subject ) = 0;
        virtual WHRESULT SetOptions( MsoFileFindOptions __Options ) = 0;
        virtual WHRESULT SetMatchCase( WVARIANT_BOOL __MatchCase ) = 0;
        virtual WHRESULT SetText( WBStr __Text ) = 0;
        virtual WHRESULT SetPatternMatch( WVARIANT_BOOL __PatternMatch ) = 0;
        virtual WHRESULT SetDateSavedFrom( WVARIANT __DateSavedFrom ) = 0;
        virtual WHRESULT SetDateSavedTo( WVARIANT __DateSavedTo ) = 0;
        virtual WHRESULT SetSavedBy( WBStr __SavedBy ) = 0;
        virtual WHRESULT SetDateCreatedFrom( WVARIANT __DateCreatedFrom ) = 0;
        virtual WHRESULT SetDateCreatedTo( WVARIANT __DateCreatedTo ) = 0;
        virtual WHRESULT SetView( MsoFileFindView __View ) = 0;
        virtual WHRESULT SetSortBy( MsoFileFindSortBy __SortBy ) = 0;
        virtual WHRESULT SetListBy( MsoFileFindListBy __ListBy ) = 0;
        virtual WHRESULT SetSelectedFile( int __SelectedFile ) = 0;
        virtual WHRESULT Execute( void ) = 0;
        virtual WHRESULT Load( WBStr __bstrQueryName ) = 0;
        virtual WHRESULT Save( WBStr __bstrQueryName ) = 0;
        virtual WHRESULT Delete( WBStr __bstrQueryName ) = 0;
        virtual WHRESULT GetFileType( long * __resultFileType ) = 0;
        virtual WHRESULT SetFileType( long __FileType ) = 0;
};

class _IFind : public WOleDispatchHelper {

    public:

        _IFind();
        ~_IFind();

        /* Methods */
        WBString GetSearchPath( void );
        WBString GetName( void );
        WVARIANT_BOOL GetSubDir( void );
        WBString GetTitle( void );
        WBString GetAuthor( void );
        WBString GetKeywords( void );
        WBString GetSubject( void );
        MsoFileFindOptions GetOptions( void );
        WVARIANT_BOOL GetMatchCase( void );
        WBString GetText( void );
        WVARIANT_BOOL GetPatternMatch( void );
        WVariant GetDateSavedFrom( void );
        WVariant GetDateSavedTo( void );
        WBString GetSavedBy( void );
        WVariant GetDateCreatedFrom( void );
        WVariant GetDateCreatedTo( void );
        MsoFileFindView GetView( void );
        MsoFileFindSortBy GetSortBy( void );
        MsoFileFindListBy GetListBy( void );
        int GetSelectedFile( void );
        _DualIFoundFiles * GetResults( void );
        int Show( void );
        void SetSearchPath( WBString __SearchPath );
        void SetName( WBString __Name );
        void SetSubDir( WVARIANT_BOOL __SubDir );
        void SetTitle( WBString __Title );
        void SetAuthor( WBString __Author );
        void SetKeywords( WBString __Keywords );
        void SetSubject( WBString __Subject );
        void SetOptions( MsoFileFindOptions __Options );
        void SetMatchCase( WVARIANT_BOOL __MatchCase );
        void SetText( WBString __Text );
        void SetPatternMatch( WVARIANT_BOOL __PatternMatch );
        void SetDateSavedFrom( WVariant __DateSavedFrom );
        void SetDateSavedTo( WVariant __DateSavedTo );
        void SetSavedBy( WBString __SavedBy );
        void SetDateCreatedFrom( WVariant __DateCreatedFrom );
        void SetDateCreatedTo( WVariant __DateCreatedTo );
        void SetView( MsoFileFindView __View );
        void SetSortBy( MsoFileFindSortBy __SortBy );
        void SetListBy( MsoFileFindListBy __ListBy );
        void SetSelectedFile( int __SelectedFile );
        void Execute( void );
        void Load( WBString __bstrQueryName );
        void Save( WBString __bstrQueryName );
        void Delete( WBString __bstrQueryName );
        long GetFileType( void );
        void SetFileType( long __FileType );

        _IFind & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _IFind & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualFoundFiles : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetApplication( WPIDispatch * __resultApplication ) = 0;
        virtual WHRESULT GetCreator( long * __resultCreator ) = 0;
        virtual WHRESULT GetItem( int __Index, WBStr * __resultItem ) = 0;
        virtual WHRESULT GetCount( long * __resultCount ) = 0;
        virtual WHRESULT Get_NewEnum( WPIUnknown * __result_NewEnum ) = 0;
};

class _FoundFiles : public WOleDispatchHelper {

    public:

        _FoundFiles();
        ~_FoundFiles();

        /* Methods */
        WPIDispatch GetApplication( void );
        long GetCreator( void );
        WBString GetItem( int __Index );
        long GetCount( void );
        WPIUnknown Get_NewEnum( void );

        _FoundFiles & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _FoundFiles & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualPropertyTest : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetApplication( WPIDispatch * __resultApplication ) = 0;
        virtual WHRESULT GetCreator( long * __resultCreator ) = 0;
        virtual WHRESULT GetName( WBStr * __resultName ) = 0;
        virtual WHRESULT GetCondition( MsoCondition * __resultCondition ) = 0;
        virtual WHRESULT GetValue( WVARIANT * __resultValue ) = 0;
        virtual WHRESULT GetSecondValue( WVARIANT * __resultSecondValue ) = 0;
        virtual WHRESULT GetConnector( MsoConnector * __resultConnector ) = 0;
};

class _PropertyTest : public WOleDispatchHelper {

    public:

        _PropertyTest();
        ~_PropertyTest();

        /* Methods */
        WPIDispatch GetApplication( void );
        long GetCreator( void );
        WBString GetName( void );
        MsoCondition GetCondition( void );
        WVariant GetValue( void );
        WVariant GetSecondValue( void );
        MsoConnector GetConnector( void );

        _PropertyTest & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _PropertyTest & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualPropertyTests : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetApplication( WPIDispatch * __resultApplication ) = 0;
        virtual WHRESULT GetCreator( long * __resultCreator ) = 0;
        virtual WHRESULT GetItem( int __Index, _DualPropertyTest * * __resultItem ) = 0;
        virtual WHRESULT GetCount( long * __resultCount ) = 0;
        virtual WHRESULT Add( WBStr __Name, MsoCondition __Condition, WVARIANT __Value, WVARIANT __SecondValue, MsoConnector __Connector=1 ) = 0;
        virtual WHRESULT Remove( int __Index ) = 0;
        virtual WHRESULT Get_NewEnum( WPIUnknown * __result_NewEnum ) = 0;
};

class _PropertyTests : public WOleDispatchHelper {

    public:

        _PropertyTests();
        ~_PropertyTests();

        /* Methods */
        WPIDispatch GetApplication( void );
        long GetCreator( void );
        _DualPropertyTest * GetItem( int __Index );
        long GetCount( void );
        void Add( WBString __Name, MsoCondition __Condition, WVariant __Value, WVariant __SecondValue, MsoConnector __Connector=1 );
        void Remove( int __Index );
        WPIUnknown Get_NewEnum( void );

        _PropertyTests & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _PropertyTests & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

class __stdcall _DualFileSearch : public IDispatch {

    public:

        /* Methods */
        virtual WHRESULT GetApplication( WPIDispatch * __resultApplication ) = 0;
        virtual WHRESULT GetCreator( long * __resultCreator ) = 0;
        virtual WHRESULT GetSearchSubFolders( WVARIANT_BOOL * __resultSearchSubFolders ) = 0;
        virtual WHRESULT SetSearchSubFolders( WVARIANT_BOOL __SearchSubFolders ) = 0;
        virtual WHRESULT GetMatchTextExactly( WVARIANT_BOOL * __resultMatchTextExactly ) = 0;
        virtual WHRESULT SetMatchTextExactly( WVARIANT_BOOL __MatchTextExactly ) = 0;
        virtual WHRESULT GetMatchAllWordForms( WVARIANT_BOOL * __resultMatchAllWordForms ) = 0;
        virtual WHRESULT SetMatchAllWordForms( WVARIANT_BOOL __MatchAllWordForms ) = 0;
        virtual WHRESULT GetFileName( WBStr * __resultFileName ) = 0;
        virtual WHRESULT SetFileName( WBStr __FileName ) = 0;
        virtual WHRESULT GetFileType( MsoFileType * __resultFileType ) = 0;
        virtual WHRESULT SetFileType( MsoFileType __FileType ) = 0;
        virtual WHRESULT GetLastModified( MsoLastModified * __resultLastModified ) = 0;
        virtual WHRESULT SetLastModified( MsoLastModified __LastModified ) = 0;
        virtual WHRESULT GetTextOrProperty( WBStr * __resultTextOrProperty ) = 0;
        virtual WHRESULT SetTextOrProperty( WBStr __TextOrProperty ) = 0;
        virtual WHRESULT GetLookIn( WBStr * __resultLookIn ) = 0;
        virtual WHRESULT SetLookIn( WBStr __LookIn ) = 0;
        virtual WHRESULT Execute( MsoSortBy __SortBy=1, MsoSortOrder __SortOrder=1, WVARIANT_BOOL __AlwaysAccurate=-1, int * __resultExecute=NULL ) = 0;
        virtual WHRESULT NewSearch( void ) = 0;
        virtual WHRESULT GetFoundFiles( _DualFoundFiles * * __resultFoundFiles ) = 0;
        virtual WHRESULT GetPropertyTests( _DualPropertyTests * * __resultPropertyTests ) = 0;
};

class _FileSearch : public WOleDispatchHelper {

    public:

        _FileSearch();
        ~_FileSearch();

        /* Methods */
        WPIDispatch GetApplication( void );
        long GetCreator( void );
        WVARIANT_BOOL GetSearchSubFolders( void );
        void SetSearchSubFolders( WVARIANT_BOOL __SearchSubFolders );
        WVARIANT_BOOL GetMatchTextExactly( void );
        void SetMatchTextExactly( WVARIANT_BOOL __MatchTextExactly );
        WVARIANT_BOOL GetMatchAllWordForms( void );
        void SetMatchAllWordForms( WVARIANT_BOOL __MatchAllWordForms );
        WBString GetFileName( void );
        void SetFileName( WBString __FileName );
        MsoFileType GetFileType( void );
        void SetFileType( MsoFileType __FileType );
        MsoLastModified GetLastModified( void );
        void SetLastModified( MsoLastModified __LastModified );
        WBString GetTextOrProperty( void );
        void SetTextOrProperty( WBString __TextOrProperty );
        WBString GetLookIn( void );
        void SetLookIn( WBString __LookIn );
        int Execute( MsoSortBy __SortBy=1, MsoSortOrder __SortOrder=1, WVARIANT_BOOL __AlwaysAccurate=-1 );
        void NewSearch( void );
        _DualFoundFiles * GetFoundFiles( void );
        _DualPropertyTests * GetPropertyTests( void );

        _FileSearch & operator=( const WVariant & v ) { WOleDispatchHelper::Create( (WPIDispatch)v ); return *this; }
        _FileSearch & operator=( WPIDispatch p ) { WOleDispatchHelper::Create( p ); return *this; }
};

#pragma warning 849 4 // restore to previous warning level

#endif
